#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

bin_INT_PL := \
	bin/knit.pl \
	bin/sqlburst.pl \
	bin/rowsqlinsert.pl \
	bin/sumcrunch.pl \
	bin/tblburst.pl

bin_INT_SH := \
	bin/mk-pod-latex.sh \
	bin/mkrunoutput.sh \
	bin/mk-usage-version.sh \
	bin/pathsintex.sh \
	bin/tbltypes.sh \
	bin/treeintex.sh \
	bin/verbatimintex.sh \
	bin/versionsintex.sh \
	bin/pod-see-also-dot.sh

bin_EXT_SH := \
	bin/hgrevid.sh

bin_INT_POD := \
	$(patsubst %.sh,%.pod,$(bin_INT_SH)) \
	$(patsubst %.pl,%.pod,$(bin_INT_PL))

bin_EXT_POD := \
	$(patsubst %.sh,%.pod,$(bin_EXT_SH))

bin_MAN := \
	$(patsubst %.pod,%.1,$(bin_EXT_POD))

bin_OTHERS := \
	bin/GNUmakefile \
	bin/module.mk \
	bin/ptbltex

bin_SOURCES := \
	$(bin_INT_SH) \
	$(bin_EXT_SH) \
	$(bin_INT_PL) \
	$(bin_INT_POD) \
	$(bin_EXT_POD) \
	$(bin_OTHERS)

bin_MAN := \
	$(patsubst %.pod,%.1,$(bin_EXT_POD))

# bin/mk-usage-version.sh not generated by rule to avoid circular dependency on itself

bin_BASH_TESTME := \
	bin/mk-usage-version.sh

bin_PERL_TESTME := \
	bin/ptbltex

bin_BASH_RESULTS := \
	bin/bashsetvars \
	bin/hgrevid \
	bin/mk-pod-latex \
	bin/mkrunoutput \
	bin/pathsintex \
	bin/tbltypes \
	bin/treeintex \
	bin/verbatimintex \
	bin/versionsintex \
	bin/pod-see-also-dot

bin_PERL_RESULTS := \
	bin/knit \
	bin/rowsqlinsert \
	bin/sqlburst \
	bin/sumcrunch \
	bin/tblburst

bin_RESULTS := \
	$(bin_BASH_RESULTS) \
	$(bin_PERL_RESULTS) \
	$(bin_MAN)

# Dependencies deliberately hidden.  make install will install
# repeatedly using old md5 values.  make clean will update md5 values.
bin/md5:
	cat $(bin_SOURCES) | md5sum | awk '{print $$1}' > bin/md5

# This one is not generated by rule to avoid circular dependencies on hf/hgrevid.out
bin/hgrevid: bin/hgrevid.sh
	cat bin/hgrevid.sh > bin/hgrevid
	chmod +x bin/hgrevid

bin/sqlburst: bin/sqlburst.pl
	cat bin/sqlburst.pl > bin/sqlburst
	chmod +x bin/sqlburst

bin/sumcrunch: bin/sumcrunch.pl
	cat bin/sumcrunch.pl > bin/sumcrunch
	chmod +x bin/sumcrunch

bin/tblburst: bin/tblburst.pl
	cat bin/tblburst.pl > bin/tblburst
	chmod +x bin/tblburst

bin/rowsqlinsert: bin/rowsqlinsert.pl
	cat bin/rowsqlinsert.pl > bin/rowsqlinsert
	chmod +x bin/rowsqlinsert

bin/knit: bin/knit.pl
	cat bin/knit.pl > bin/knit
	chmod +x bin/knit

bin/bashsetvars: hf/md5
	echo '\
HFMAJVER="$(HFMAJVER)"\
HFTOP="$(HFTOP)"\
HFMAJTOP="$(HFMAJTOP)"' | sed 's/\\//g' > bin/bashsetvars

.PHONY: build_bin
build_bin: $(bin_RESULTS) bin/md5 ## Build bin

.PHONY: clean_bin
clean_bin: ## Clean bin
	rm -f $(bin_RESULTS) bin/md5

.PHONY: install_bin
install_bin: installstep1 $(bin_RESULTS) bin/md5 ## Install bin
	cp -a bin/bashsetvars install/$(HFTOP)/lib/bashsetvars
	cp -a bin/hgrevid install/$(HFTOP)/bin/hgrevid
	cp -a $(bin_MAN) install/$(HFTOP)/man/man1
