#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

#  Usage: pod-see-also-dot foo.pod bar.pod ... > out.dot
#
#  Constructs the graphviz dot file of which man page refers to which
#  others in its SEE ALSO section.  Depends on second pod line after
#  SEE ALSO to contain all of the references, and to be blank if there
#  are no references.  foo.pod should look like this:
#
#	=head1 SEE ALSO
#
#	L<diffdb(1)>, L<dropdb(1)>, L<forkdb(1)>, L<hfgen(1)>, L<hf-reloaddb(1)>
#
#	L<http://www.workver.com>       the Working Version homepage
#
#  or this:
#
#	=head1 SEE ALSO
#
#
#
#	L<http://www.workver.com>       the Working Version homepage

cat << 'EOF'
#
#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew
#

digraph g {

graph [size="7.5,10",margin="0"];

EOF

(
	for i
	do
		echo $i
	done
) | \
LANG=C sort | \
grep -v '^hf/hf-top\.pod$' | \
while read line
do
	POINTING=$(echo $(basename $line) | sed -e 's/\.pod$/(1)/' -e 's/\.5pod$/(5)/')
	grep -A 2 '^=head1 SEE ALSO$' $line | \
		tail -1 | \
		sed -e 's/L<//g' -e 's/>//g' -e 's/ //g' -e 's/^$/NULL/' | \
		tr ',' '\012' | \
		sed -e 's/^/"/' -e 's/$/";/' -e "s|^|\"$POINTING\" -> |"
done

cat << 'EOF'
}
EOF
