#!/usr/bin/perl

#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

$tablename = $ARGV[0];

if ("$tablename" eq "") {
	die "Usage: $0 tablename.rdb\n";
	exit 1;
}

$tablename =~ s/\.rdb$//;
$tablename =~ s/\..*$//;
$tablename =~ s|^.*/||;

while (<>) {
	if (/^\s*#/) {		# comment
		next;
	}
	chop;
	@F = split (/\t/, $_);
	if (++$lln == 1) {	# column names line
		@H = @F;	# save headers
		$nrf = @H;	# nr of fields
		next;
	}
	if ($lln == 2) {	# column definitions line
		last;
	}
}

while (<>) {
	chop;
	@F = split (/\t/, $_, $nrf);

	foreach $i (@F) {
		$i =~ s/'/''/g;
	}

	print "insert into $tablename (" .
		join (", ", @H) .
		") values ('" .
		join ("', '", @F) .
		"');\n";
}
