#!/usr/bin/perl

#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

open (TEXSQL, ">&3") || die "must redirect fd 3 somewhere";

#----- Before walking any tables ----------------------------------------------

#----- For each table ---------------------------------------------------------

#$olddollarslash = $/;
#undef ($/);

foreach $file (@ARGV) {

	$tablename = $file;
	$tablename =~ s/\..*$//;
	$tablename =~ s|^.*/||;

	open (FILE, '<', $file) || die "$!";
	$count = 1;
	$wholefile = "";
	$texwholefile = "";
	while (<FILE>) {
		$line = $_;
		$wholefile .= $line;
		if ($count < 200) {
			$texwholefile .= $line;
		} elsif ($count == 200) {
			$texwholefile .= "\n[Remainder of sql omitted for brevity]\n";
		}
		$count++;
	}
	close (FILE);

	&sqlprint ($wholefile);
	&sqlprint ("\n");
	&texsqlprint ("
\\subsubsection{$tablename table}

");
	&texsqlcode ($texwholefile);
}

#----- After all table walks --------------------------------------------------

#----- Subroutines ------------------------------------------------------------

sub sqlprint {

	my ($string) = @_;

	print STDOUT $string;
}

#------------------------------------------------------------------------------

sub texsqlprint {

	my ($string) = @_;

	print TEXSQL $string;
}

#------------------------------------------------------------------------------

sub texsqlcode {

	my ($string) = @_;

	print TEXSQL "\\begin{quote}
\\begin{verbatim}
${string}\\end{verbatim}
\\end{quote}
";
}

#------------------------------------------------------------------------------
