#!/bin/bash -euET

#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

CLEANEXIT=0
trap '
SAVEDSTATUS=$?
set +x
if [ "${CLEANEXIT:-0}" -ne 1 ]
then
	echo "${0##*/}: FATAL Unexpected return value of ${SAVEDSTATUS:-?}, line number ${ERR_LINENO:-?}, quitting" 1>&2
	exit $SAVEDSTATUS
fi' EXIT

trap 'ERR_LINENO=$LINENO' ERR

set -o pipefail

#-----

INSTALLLOC=/opt/rdb-2.1

if [ -d $INSTALLLOC ]
then
	echo "ERROR dir '$INSTALLLOC' exists, is rdb already installed?" 1>&2
	CLEANEXIT=1
	exit 1
fi

(set -x
	sudo mkdir $INSTALLLOC
	sudo chown ${USER}.${USER} $INSTALLLOC)

mkdir /tmp/rdb-download.$$
cd /tmp/rdb-download.$$

mkdir src bin doc

cd src

wget -r -l 1 -p http://web.mit.edu/databases/src/rdb

cd ..

SRC=src/web.mit.edu/databases/src/rdb

mv $SRC/Info.RDB doc
mv $SRC/RDB.ps doc

mv $SRC/column bin
mv $SRC/compute bin
mv $SRC/dataent bin
mv $SRC/etbl bin
mv $SRC/headchg bin
mv $SRC/jointbl bin
mv $SRC/lst2tbl bin
mv $SRC/mergetbl bin
mv $SRC/mktbl bin
mv $SRC/ptbl bin
mv $SRC/rdb bin
mv $SRC/repair bin
mv $SRC/reporttbl bin
mv $SRC/row bin
mv $SRC/search bin
mv $SRC/sorttbl bin
mv $SRC/subtotal bin
mv $SRC/summ bin
mv $SRC/tbl2lst bin
mv $SRC/uniqtbl bin
mv $SRC/valid bin

chmod +x bin/*

mv bin doc $INSTALLLOC

cd
rm -r /tmp/rdb-download.$$

#-----

CLEANEXIT=1
exit 0
