#!/bin/bash -euET

#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

#
#  Usage:
#
#	client-networked-precise.sh
#

CLEANEXIT=0
trap '
SAVEDSTATUS=$?
set +x
if [ "${CLEANEXIT:-0}" -ne 1 ]
then
	echo "${0##*/}: FATAL Unexpected return value of ${SAVEDSTATUS:-?}, line number ${ERR_LINENO:-?}, quitting" 1>&2
	exit $SAVEDSTATUS
fi' EXIT

trap 'ERR_LINENO=$LINENO' ERR

set -o pipefail

#-----

# Make lightdm login screen not offer usernames or guest session
for i in 'greeter-hide-users=true' 'allow-guest=false'
do
	if ! grep -q "^$i\$" /etc/lightdm/lightdm.conf
	then
		echo "$i" >> /etc/lightdm/lightdm.conf
	fi
done

# Allow incoming ssh
apt-get -y install openssh-server openssh-blacklist openssh-blacklist-extra

# Backward compatibility with twm use
### apt-get -y install twm
### apt-get -y install tcsh
### apt-get -y install xscreensaver

# NFS home dirs
apt-get -y install nfs-common ## nfs-kernel-server

apt-get -y install autofs

### if ! grep -q "XXX-server:/export/home1" /etc/fstab
### then
###	echo '
###
### # Use this instead of automounter, servers much more reliable now
### XXX-server:/export/home1 /home nfs rw,nodev,nosuid,intr,soft,bg 0 0' >> /etc/fstab
### fi

# Mail transport
apt-get -y install postfix postfix-doc
sed 's|^myorigin =.*$|myorigin = example.com|' < /etc/postfix/main.cf > /tmp/pp ; cat /tmp/pp > /etc/postfix/main.cf ; postfix reload

apt-get -y install bsd-mailx

### apt-get -y install mysql-server mysql-client mysql-navigator mysql-workbench emma
### mysql_secure_installation

#-----

CLEANEXIT=1
exit 0
