#!/bin/bash -euET

#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

#
#  A step in capturing servers and clients
#

CLEANEXIT=0
trap '
SAVEDSTATUS=$?
set +x
if [ "${CLEANEXIT:-0}" -ne 1 ]
then
	echo "${0##*/}: FATAL Unexpected return value of ${SAVEDSTATUS:-?}, line number ${ERR_LINENO:-?}, quitting" 1>&2
	exit $SAVEDSTATUS
fi' EXIT

trap 'ERR_LINENO=$LINENO' ERR

set -o pipefail

#-----

: ${FARHOST:?FATAL env var FARHOST not defined, should be name of far host, quitting}

hfdist -wd -v 5 -r -l s1.hflayers -h $FARHOST.hfhosts

touch repo/h/$FARHOST/s1.timestamp

#-----

CLEANEXIT=1
exit 0
