#!/bin/bash -euET

#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

#
#  A step in capturing servers and clients
#

CLEANEXIT=0
trap '
SAVEDSTATUS=$?
set +x
if [ "${CLEANEXIT:-0}" -ne 1 ]
then
	echo "${0##*/}: FATAL Unexpected return value of ${SAVEDSTATUS:-?}, line number ${ERR_LINENO:-?}, quitting" 1>&2
	exit $SAVEDSTATUS
fi' EXIT

trap 'ERR_LINENO=$LINENO' ERR

set -o pipefail

#-----

: ${FARHOST:?FATAL env var FARHOST not defined, should be name of far host, quitting}

mkdir -p repo/h/$FARHOST/s5

(set -x ; sl -k repo/h/$FARHOST/s4/d > repo/h/$FARHOST/s5/d.sl)
(set -x ; sl -k repo/h/$FARHOST/s4/g > repo/h/$FARHOST/s5/g.sl)
(set -x ; sl -k repo/h/$FARHOST/s4/o > repo/h/$FARHOST/s5/o.sl)
(set -x ; sl -k repo/h/$FARHOST/s4/w > repo/h/$FARHOST/s5/w.sl)

touch repo/h/$FARHOST/s5.timestamp

#-----

CLEANEXIT=1
exit 0
