#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

package HF::Db;
use strict;

use DBI;

sub new {

	my $proto = shift;

	my $class = ref ($proto) || $proto;

	my $self = {
		'dbh'		=> undef
	};

	bless ($self, $class);
	return ($self);
}

sub connect {

	my $self = shift;
	my $dbname = shift;

	if (!($self->{'dbh'} = DBI->connect ('dbi:mysql:' . $dbname, 'root', '',
		{RaiseError => 1, AutoCommit => 0}))) {

		HF::Report->report (3, 0, "FATAL cannot connect to mysql database named '$dbname'");
	}

	return ($self->{'dbh'});
}

sub disconnect {

	my $self = shift;

	$self->{'dbh'}->commit;
	$self->{'dbh'}->disconnect;
}

1;
