#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

db_MODULES := \
	db/HF/Db.pm

db_EXT_SH := \
	db/diffdb.sh \
	db/dropdb.sh \
	db/forkdb.sh \
	db/lsdb.sh

db_EXT_POD := \
	$(patsubst %.sh,%.pod,$(db_EXT_SH))

db_HELP := \
	db/diffdb.help \
	db/dropdb.help \
	db/forkdb.help \
	db/lsdb.help

db_OTHERS := \
	db/module.mk \
	db/GNUmakefile

db_SOURCES := \
	$(db_MODULES) \
	$(db_EXT_SH) \
	$(db_EXT_POD) \
	$(db_HELP) \
	$(db_OTHERS)

db_MAN := \
	$(patsubst %.pod,%.1,$(db_EXT_POD))

db_BASH_TESTME :=

db_PERL_TESTME :=

db_BASH_RESULTS := \
	db/diffdb \
	db/dropdb \
	db/forkdb \
	db/lsdb

db_PERL_RESULTS :=

db_RESULTS := \
	$(db_BASH_RESULTS) \
	$(db_PERL_RESULTS) \
	$(db_MAN)

# Dependencies deliberately hidden.  make install will install
# repeatedly using old md5 values.  make clean will update md5 values.
db/md5:
	cat $(db_SOURCES) | md5sum | awk '{print $$1}' > db/md5

db/diffdb: db/diffdb.help

db/dropdb: db/dropdb.help

db/forkdb: db/forkdb.help

db/lsdb: db/lsdb.help

.PHONY: build_db
build_db: $(db_RESULTS) db/md5 ## Build db

.PHONY: clean_db
clean_db: ## Clean db
	rm -f $(strip $(db_RESULTS) db/md5)

.PHONY: install_db
install_db: installstep1 $(db_RESULTS) db/md5 ## Install db
	cp -a db/diffdb install/$(HFTOP)/bin/diffdb
	cp -a db/dropdb install/$(HFTOP)/bin/dropdb
	cp -a db/forkdb install/$(HFTOP)/bin/forkdb
	cp -a db/lsdb install/$(HFTOP)/bin/lsdb
	cp -a db/HF/Db.pm install/$(HFTOP)/lib/HF/Db.pm
	cp -a $(db_MAN) install/$(HFTOP)/man/man1
