#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

dot_DOT := \
	dot/arch.dot \
	dot/harmonize.dot \
	dot/mailflow.dot

dot_OTHERS := \
	dot/GNUmakefile \
	dot/module.mk

dot_SOURCES := \
	$(dot_DOT) \
	$(dot_OTHERS)

dot_BASH_TESTME :=

dot_PERL_TESTME :=

dot_BASH_RESULTS :=

dot_PERL_RESULTS :=

dot_RESULTS := \
	$(dot_BASH_RESULTS) \
	$(dot_PERL_RESULTS) \
	dot/arch.pdf \
	dot/arch.ps \
	dot/harmonize.pdf \
	dot/harmonize.ps \
	dot/mailflow.pdf \
	dot/mailflow.ps \
	dot/seealso.dot \
	dot/seealso.pdf \
	dot/seealso.ps

# Dependencies deliberately hidden.  make install will install
# repeatedly using old md5 values.  make clean will update md5 values.
dot/md5:
	cat $(dot_SOURCES) | md5sum | awk '{print $$1}' > dot/md5

# Want dependency on $(ALLEXTPODS), but can't get
# ALLEXTPODS defined earlier for this script to use it
dot/seealso.dot: bin/pod-see-also-dot hf/hf.pod
	bin/pod-see-also-dot $(ALLEXTPODS) > dot/seealso.dot

.PHONY: build_dot
build_dot: $(dot_RESULTS) dot/md5 ## Build dot

.PHONY: clean_dot
clean_dot: ## Clean dot
	rm -f $(strip $(dot_RESULTS) dot/md5)

.PHONY: install_dot
install_dot: installstep1 $(dot_RESULTS) dot/md5 ## Install dot
