#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

# select table_name,create_options,update_time,create_time,check_time from information_schema.tables where table_schema = 'hfexample1' and table_name = 'hosts' ;
#
# http://dev.mysql.com/doc/refman/5.1/en/tables-table.html
#
# 	Posted by Naref Szolik on May 27 2012 1:03pm
#
# 	UPDATE_TIME only stores values for a subset of the available
# 	table storage engines.
#
# 	Posted by Chris Calender on March 7 2013 8:17pm
#
# XXX	UPDATE_TIME works for MyISAM, not InnoDB.

use DBI;

#-----

if ($#ARGV == -1) {
	&print_version;
	warn ("\n");
	&print_usage;
	exit (0);
}

if ($ENV{HFGENDB} eq "") {
	die "FATAL env var HFGENDB not defined, should be name of gen database\n";
}

#-----

my $hfgenpassword;
my $dbh;
my $sth1;
my $siteshash;
my $createtime;
my $updatetime;
my $outtime;

$hfgenpassword = `cat ~/.hfgen-password`;
chop ($hfgenpassword);

$dbh = DBI->connect ("dbi:mysql:$ENV{HFGENDB}", "hfgen", $hfgenpassword,
	{RaiseError => 1, AutoCommit => 0, LongReadLen => 1000000}) ||
	die "FATAL: can't open initial database connection, '$DBI::errstr'";

#-----

$sth1 = $dbh->prepare (q{
select unix_timestamp(max(create_time)) as createtime, unix_timestamp(max(update_time)) as updatetime from information_schema.tables where table_schema = '} . $ENV{HFGENDB} . q{' and table_name in (} . "'" . join ("', '", @ARGV) . "'" . q{);
});
$sth1->execute;
$siteshash = $sth1->fetchrow_hashref;
$createtime = $$siteshash{"createtime"};
$updatetime = $$siteshash{"updatetime"};

warn "# createtime $createtime updatetime $updatetime\n";

$outtime = 0;
if ($createtime > $outtime) { $outtime = $createtime; }
if ($updatetime > $outtime) { $outtime = $updatetime; }

print "$outtime\n";

#-----

$sth1->finish;
$dbh->disconnect;

exit (0);
