export HFGENDB=${HFGENDB:-@@@ EXAMPLEDB @@@}

HFTOP='/@@@ HFTOP @@@'
GENTOPINST="$HFTOP/gen"
GENVERDIR="hfgen.out/$HFGENDB"

# Want hfgen to run both in hg repo and against installed location.
# So it looks for dir hfgen.out or symlink to it in the current dir,
# and if it doesn't find it, switches to the install location
if [ ! -d hfgen.out ]
then
	if [ "${1:-}" != '-r' ]
	then
		echo "NOTICE hfgen.out is not in cd,
NOTICE doing chdir to $GENTOPINST" 1>&2
	fi
	cd $GENTOPINST
	GENROOT="$GENTOPINST/$GENVERDIR"
else
	GENROOT=$GENVERDIR
fi

if [ "${1:-}" = '-r' ]
then
	echo $GENROOT
	CLEANEXIT=1
	exit 0
fi

if ! cat ~/.hfgen-password > /dev/null
then
	echo "FATAL password file ~/.hfgen-password not readable" 1>&2
	CLEANEXIT=1
	exit 1
fi

if ! type -p mysql > /dev/null
then
	echo "FATAL mysql command not available, quitting" 1>&2
	CLEANEXIT=1
	exit 1
fi

#-----

echo "== HFGENDB=$HFGENDB"

if [ -n "${1:-}" ]
then
	PIECES=''
	for i
	do
		if [ -x "$i/Generate" ]
		then
			PIECES="$PIECES $i/Generate"
		else
			echo "FATAL '$i/Generate' not found, quitting" 1>&2
			CLEANEXIT=1
			exit 1
		fi
	done

	mkdir -p $GENVERDIR
else
	PIECES=`echo */Generate`

	rm -rf $GENVERDIR
	mkdir -p $GENVERDIR
fi

for i in $PIECES
do
	THISPIECE=`dirname $i`
	echo -n Generating $THISPIECE ''
	cd $THISPIECE
	./Generate
	cd ..
done
