#!/usr/bin/perl

#
#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew
#
#  Usage:
#
#	./gsub.pl '%%%-SYMBOL-TO-REPLACE-%%%' file-of-contents-to-replace-with \
#		'%%%-NEXT-SYMBOL-%%%' next-filename \
#		< infile > outfile
#  Bugs:
#
#	Only replaces characters of symbol.  If symbol is on its own
#	line and substituting file ends with newline, the newline of
#	symbol's line remains, giving the impression of the
#	substitution having added a newline.
#

while ($key = shift (@ARGV), $file = shift (@ARGV), $file ne undef) {

	push (@keys, $key);

	open (FILE, '<', $file) || die "$!";
	{
		local ($/);
		$contents{$key} = <FILE>;
	}
	close (FILE);
}

while (<>) {

	$line = $_;
	foreach $i (@keys) {
		$line =~ s/$i/$contents{$i}/g;
	}
	print $line;
}

exit (0);
