#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

package HF::NULLstream;
use strict;

sub new {

	my $proto = shift;

	my $class = ref ($proto) || $proto;

	my $self = {

		'firsttime'	=> 1,
		'isdone'	=> 0
	};

	bless ($self, $class);

	return ($self);
}

sub next {

	my $self = shift;

	my $nextname;
	my $res;

	if ($self->{'isdone'} == 1) {
		HF::Report->report (4, 1, "FATAL called after end of walk");
	}

	$res = {
		'startdir' => '.',
		'encstartdir' => '.'
	};

	if ($self->{'firsttime'} == 1) {

		$res->{'path'} = '.';
		$res->{'encpath'} = '.';

		($res->{'dev'}, $res->{'inode'}, $res->{'mode'},
			$res->{'links'}, $res->{'owner'}, $res->{'group'},
			$res->{'rdev'}, $res->{'size'}, $res->{'atime'},
			$res->{'mtime'}, $res->{'ctime'},
			$res->{'blksize'}, $res->{'blocks'}) = (64513, 10000, 0040755, 2, 0, 0, undef, 4096, 0, 0, 0, 4096, 8);

		$res->{'type'} = 0040000;
		$res->{'perms'} = 00755;

		$res->{'checksum'} = undef;

		$res->{'name'} = '.';
		$res->{'encname'} = '.';

		$self->{'firsttime'} = 0;
	} else {
		$res->{'path'} = '';
		$res->{'encpath'} = '';

		$self->{'isdone'} = 1;
	}

	return ($res);
}

1;
