#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

HFPREFIX='/@@@ HFPREFIX @@@'
HFMAJLINK='@@@ HFMAJLINK @@@'

if ! type -p ssh > /dev/null
then
	echo "FATAL ssh command not available, quitting" 1>&2
	CLEANEXIT=1
	exit 1
fi

REMSSH="${1:-}"

if [ -z "$REMSSH" ]
then
	CLEANEXIT=1
	echo 'This script copies an installation of Host Factory from another
system by pulling it in tar format over ssh.  The destination can be
given as an arg.

Enter user@hostname for ssh and press RET.
To cancel do ^C, readline editing is active'
	read -e -p '> ' -i 'root@client.example.com' REMSSH
	CLEANEXIT=0
	echo
fi

# Substitute the variables, and print the lines with substitutions as they are run
bash -v << EOF 2>&1
mkdir -p $HFPREFIX
rm -f $HFPREFIX/$HFMAJLINK
ssh $REMSSH "cd $HFPREFIX ; tar -cf - ." | (cd $HFPREFIX ; tar -xvpf -)
EOF
