#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

HFPREFIX='/@@@ HFPREFIX @@@'
HFMAJLINK='@@@ HFMAJLINK @@@'

DELETE=''
ORCOLON='|| :'
if [ "${1:-}" = '-d' ]
then
	DELETE='-d'
	ORCOLON=''
	shift
fi

if ! type -p ssh > /dev/null
then
	echo "FATAL ssh command not available, quitting" 1>&2
	CLEANEXIT=1
	exit 1
fi

if [ -z "${1:-}" ]
then
	echo "FATAL no hfhosts arguments" 1>&2
	CLEANEXIT=0
	exit 1
fi

if [ ! -e "$1" ]
then
	echo "FATAL file doesn't exist for hfhosts argument" 1>&2
	CLEANEXIT=0
	exit 1
fi

EXITFAIL=0
for HFHOSTS
do
	RESULT=1
	for i in `/bin/ls -dt ${HFPREFIX}/*`
	do
		CMDCHECK="$i/bin/hfdist -v 2 -c -h $HFHOSTS $HFPREFIX $HFPREFIX"
		echo "-- trying $CMDCHECK
"
		if $CMDCHECK 2>&1
		then
			# no "-d" by default, don't want to remove other versions shared between other hosts
			# $ORCOLON in case of no -d
			CMDPROP1="$i/bin/hfdist -v 4 -w -t 101 $DELETE -k -h $HFHOSTS -O /tmp/hf-bootstrap-push-hfdist-hfhosts-$$.hflog $HFPREFIX $HFPREFIX $ORCOLON"
			# always update symlink
			CMDPROP2="$i/bin/hflayers copyone $HFPREFIX/$HFMAJLINK $HFPREFIX/$HFMAJLINK | $i/bin/hfdist -v 4 -wd -t 101 -h $HFHOSTS -l -"
			echo "
-- that worked, now propagating whole tree of installs with it
"
			echo
			bash -v << EOF 2>&1
$CMDPROP1
EOF
			echo
			bash -v << EOF 2>&1
$CMDPROP2
EOF
			RESULT=$?
			break
		fi
		echo
	done

	if [ $RESULT -ne 0 ]
	then
		echo "-- sorry, didn't succeed."
		EXITFAIL=1
	fi
done

echo
echo "Consider hflog /tmp/hf-bootstrap-push-hfdist-hfhosts-$$.hflog"

if [ $EXITFAIL -eq 1 ]
then
	CLEANEXIT=1
	exit 1
else
	CLEANEXIT=1
	exit 0
fi
