#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

HFPREFIX='/@@@ HFPREFIX @@@'
HFMAJLINK='@@@ HFMAJLINK @@@'

if ! type -p ssh > /dev/null
then
	echo "FATAL ssh command not available, quitting" 1>&2
	CLEANEXIT=1
	exit 1
fi

REMSSH="${1:-}"

if [ -z "$REMSSH" ]
then
	CLEANEXIT=1
	echo 'This script tests which of the existing installations of Host Factory
will interoperate with Host Factory installations on other systems.
The destination can be given as an arg.

Enter user@hostname for ssh and press RET.
To cancel do ^C, readline editing is active'
	read -e -p '> ' -i 'root@client.example.com' REMSSH
	CLEANEXIT=0
	echo
fi

CMDTAIL="$HFPREFIX $HFPREFIX $REMSSH"
WORKEDCOUNT=0
for i in `/bin/ls -dt ${HFPREFIX}/*`
do
	CMDCHECK="$i/bin/hfdist -v 2 -c $CMDTAIL"
	echo "-- trying $CMDCHECK
"
	if $CMDCHECK 2>&1
	then
		echo "$i" >> /tmp/hfbootstrap-test-hf.$$
		WORKEDCOUNT=$(($WORKEDCOUNT + 1))
	fi
	echo
done

if [ $WORKEDCOUNT -gt 0 ]
then
	echo "-- these $WORKEDCOUNT installations passed checkreadiness:
"
	cat /tmp/hfbootstrap-test-hf.$$
else
	echo "-- sorry, found no working installations."
fi

rm -f /tmp/hfbootstrap-test-hf.$$
