#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

HFPREFIX='/@@@ HFPREFIX @@@'
HFMAJLINK='@@@ HFMAJLINK @@@'

DELETE=''
ORCOLON='|| :'
if [ "${1:-}" = '-d' ]
then
	DELETE='-d'
	ORCOLON=''
	shift
fi

if ! type -p ssh > /dev/null
then
	echo "FATAL ssh command not available, quitting" 1>&2
	CLEANEXIT=1
	exit 1
fi

if [ -z "${1:-}" ]
then
	CLEANEXIT=1
	echo 'This script updates a remote instance of the Host Factory installation
tree by copying the local installation tree.  It tests which existing
installations of Host Factory will interoperate with a remote system,
and does the copy with the first one that works.  The destination can
be given as an arg.

Enter user@hostname for ssh and press RET.
To cancel do ^C, readline editing is active'
	read -e -p '> ' -i 'root@client.example.com' REMSSH
	CLEANEXIT=0
	set -- "$REMSSH"
	echo
fi

for REMSSH
do
	RESULT=1
	for i in `/bin/ls -dt ${HFPREFIX}/*`
	do
		CMDCHECK="$i/bin/hfdist -v 2 -c $HFPREFIX $HFPREFIX $REMSSH"
		echo "-- trying $CMDCHECK
"
		if $CMDCHECK 2>&1
		then
			# no "-d" by default, don't want to remove other versions shared between other hosts
			# $ORCOLON in case of no -d
			CMDPROP1="$i/bin/hfdist -v 4 -w -t 101 $DELETE -k -O /tmp/hf-bootstrap-push-hfdist-$$.hflog $HFPREFIX $HFPREFIX $REMSSH $ORCOLON"
			# always update symlink
			CMDPROP2="$i/bin/hflayers copyone $HFPREFIX/$HFMAJLINK $HFPREFIX/$HFMAJLINK | $i/bin/hfdist -v 4 -wd -t 101 -l - $REMSSH"
			echo "
-- that worked, now propagating whole tree of installs with it
"
			bash -v << EOF 2>&1
$CMDPROP1
EOF
			echo
			bash -v << EOF 2>&1
$CMDPROP2
EOF
			RESULT=$?
			break
		fi
		echo
	done

	if [ $RESULT -ne 0 ]
	then
		echo "-- sorry, didn't succeed."
	fi
done

echo
echo "Consider hflog /tmp/hf-bootstrap-push-hfdist-$$.hflog"
