#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

HFPREFIX='/@@@ HFPREFIX @@@'
HFMAJLINK='@@@ HFMAJLINK @@@'

if ! type -p ssh > /dev/null
then
	echo "FATAL ssh command not available, quitting" 1>&2
	CLEANEXIT=1
	exit 1
fi

if ! type -p rdist > /dev/null
then
	echo "FATAL rdist command not available, quitting" 1>&2
	CLEANEXIT=1
	exit 1
fi

if [ -z "${1:-}" ]
then
	CLEANEXIT=1
	echo 'This script copies an installation tree of Host Factory to another
system using rdist.  The destination can be given as an arg.

Enter user@hostname for ssh and press RET.
To cancel do ^C, readline editing is active'
	read -e -p '> ' -i 'root@client.example.com' REMSSH
	CLEANEXIT=0
	set -- "$REMSSH"
	echo
fi

for REMSSH
do
	# Print the lines with substitutions as rdist reads them.
	# No "remove", don't want to remove unrelated versions shared
	# with other hosts, but do change symlink

	bash -v << EOF 2>&1
ssh $REMSSH "rm -f $HFPREFIX/$HFMAJLINK"
EOF
	echo
	tee /dev/tty << EOF | (set -v ; rdist -f -)
($HFPREFIX) -> ($REMSSH)
	install -onumchkgroup,numchkowner,compare $HFPREFIX ;
EOF
done
