#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

HFPREFIX='/@@@ HFPREFIX @@@'
HFMAJLINK='@@@ HFMAJLINK @@@'

DELETE=''
if [ "${1:-}" = '-d' ]
then
	DELETE='--delete'
	shift
fi

if ! type -p ssh > /dev/null
then
	echo "FATAL ssh command not available, quitting" 1>&2
	CLEANEXIT=1
	exit 1
fi

if ! type -p rsync > /dev/null
then
	echo "FATAL rsync command not available, quitting" 1>&2
	CLEANEXIT=1
	exit 1
fi

if [ -z "${1:-}" ]
then
	CLEANEXIT=1
	echo 'This script copies an installation tree of Host Factory to another
system using rsync.  The destination can be given as an arg.

Enter user@hostname for ssh and press RET.
To cancel do ^C, readline editing is active'
	read -e -p '> ' -i 'root@client.example.com' REMSSH
	CLEANEXIT=0
	set -- "$REMSSH"
	echo
fi

for REMSSH
do
	# Substitute the variables, and print the lines with substitutions as
	# they are run.  No "--delete" by default, don't want to remove unrelated
	# versions shared with other hosts, but do change symlink

	# XXX for some reason, second command doesn't happen when these two bash -v are combined
	bash -v << EOF 2>&1
ssh $REMSSH "mkdir -p $HFPREFIX ; rm -f $HFPREFIX/$HFMAJLINK"
EOF
	echo
	bash -v << EOF 2>&1
rsync -ai -H --progress --checksum $DELETE $HFPREFIX/ $REMSSH:$HFPREFIX/
EOF
done
