#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

HFPREFIX='/@@@ HFPREFIX @@@'
HFMAJLINK='@@@ HFMAJLINK @@@'

if ! type -p ssh > /dev/null
then
	echo "FATAL ssh command not found on path, quitting" 1>&2
	CLEANEXIT=1
	exit 1
fi

if [ -z "${1:-}" ]
then
	CLEANEXIT=1
	echo 'This script copies an installation tree of Host Factory to another
system using tar over ssh.  The destination can be given as an arg.

Enter user@hostname for ssh and press RET.
To cancel do ^C, readline editing is active'
	read -e -p '> ' -i 'root@client.example.com' REMSSH
	CLEANEXIT=0
	set -- "$REMSSH"
	echo
fi

for REMSSH
do
	# Substitute the variables, and print the lines with substitutions as they are run
	bash -v << EOF 2>&1
(cd $HFPREFIX ; tar -cf - .) | ssh $REMSSH "mkdir -p $HFPREFIX ; rm -f $HFPREFIX/$HFMAJLINK ; cd $HFPREFIX ; tar -xvpf -"
EOF
done
