#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

use IO::Handle;

my $globwalk;
my $walkhash;
my $thepid;
my $thename;
my @output;
my @oldoutput;
my @altoutput;
my @oldaltoutput;
my $dooutput;
my $theoutput;
my $i;
my $line;
my $linenum;
my $filenum;
my $oldfilenum;
my $displaylines = 4;

STDOUT->autoflush;

$oldfilenum = 99999;

while (1) {

	@output = ( );
	@altoutput = ( );
	$filenum = 0;

	$globwalk = HF::GLOBstream->new ('/tmp', '/tmp/hfdist_remote_status\.*', undef, 0);
	$globwalk->next;	# discard dot

	while ($walkhash = $globwalk->next, defined ($walkhash->{'inode'})) {

		$thepid = $walkhash->{'name'};
		$thepid =~ s/^.+\.(.+)$/\1/;
		$thename = '/tmp/' . $walkhash->{'name'};

		if (!(-e "/proc/$thepid")) {
			if (!(unlink ($thename))) {
				HF::Report->report (2, 2, "FAILURE unlink '$thename' failed with error '$!'");
			}
		} else {
			if (open (HFREMOTESTATUS, '<', $thename)) {
				$filenum++;
				$linenum = 0;
				while (<HFREMOTESTATUS>) {
					$line = $_;
					$linenum++;
					chop ($line);
					$line =~ s/'//g;	# protect generated bash command line
					push (@output, $line);
					if ($linenum == 4) {
						push (@altoutput, $line);
					}
				}
				close (HFREMOTESTATUS);
			}
		}
	}

	$dooutput = 0;
	if ($filenum > 1) {
		for ($i = 0;  $i < $displaylines;  $i++) {
			if (($oldaltoutput[$i] ne $altoutput[$i]) || ($oldfilenum != $filenum)) {
				$dooutput = 1;
				@oldaltoutput = @altoutput;
				$oldfilenum = $filenum;
				last;
			}
		}
	} else {
		for ($i = 0;  $i < $displaylines;  $i++) {
			if (($oldoutput[$i] ne $output[$i]) || ($oldfilenum != $filenum)) {
				$dooutput = 1;
				@oldoutput = @output;
				$oldfilenum = $filenum;
				last;
			}
		}
	}

	if ($dooutput == 1) {
		$theoutput = 'hf-sunfounderlcd ';
		if ($filenum > 4) {
			for ($i = 0;  $i < ($displaylines - 1);  $i++) {
				$theoutput .= "'" . $altoutput[$i] . "' " ;
			}
			$theoutput .= "'plus " . ($filenum - 3) . " more'";
		} elsif ($filenum > 1) {
			for ($i = 0;  $i < $displaylines;  $i++) {
				$theoutput .= "'" . $altoutput[$i] . "' " ;
			}
		} else {
			for ($i = 0;  $i < $displaylines;  $i++) {
				$theoutput .= "'" . $output[$i] . "' " ;
			}
		}
		print "$theoutput\n";
	}

	sleep (1);
}
