#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

# Tree to walk is relative to filename of this script
# pwd -P because I want the real directory,
# not the symlink on the path used to get there
EXEDIRNAME=`dirname $0`
EXEDIR=`(cd "$EXEDIRNAME" ; pwd -P)`
START=`dirname "$EXEDIR"`

# Use slash after START if you need to go through hf-n symlink
# (this was before pwd changed to pwd -P to get real dir)
MD5RESULT=$(find $START -type f \( \( -path $START/doc/make-install -prune \) -o -print0 \) | sort -z | xargs -0r cat | md5sum | awk '{print $1}')

if [ "$MD5RESULT" = 'd41d8cd98f00b204e9800998ecf8427e' ]
then
	echo "FATAL some error resulted in the md5sum of zero-length input, quitting" 1>&2
	CLEANEXIT=1
	exit 1
fi

if [ "${1:-}" = '-a' ]
then
	LASTMOD=$(ls -1ldtr --time-style='+%a %b %e %H:%M:%S %Z %Y' $(find $START \( \! -type l \) -print) | tail -1 | awk '{printf ("%s %s %2s %s %s %s %s\n", $6, $7, $8, $9, $10, $11, $12)}')
	OLDMD5RESULT=$(grep '^hf-version' "$START/doc/make-install" | awk '{print $2}')

	if [ "$MD5RESULT" != "$OLDMD5RESULT" ]
	then
		DIFFERS="   DIFFERS!"
	else
		DIFFERS=""
	fi

	echo "This version running is:

hf-version	 ${MD5RESULT}${DIFFERS}
found at	 $START
last mod	 $LASTMOD

Original build versioning was:
"
	cat "$START/doc/make-install"
else
	echo "$MD5RESULT"
fi
