#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

HFPREFIX='/@@@ HFPREFIX @@@'
HFMAJTOP='/@@@ HFMAJTOP @@@'
HFMAJLINK='@@@ HFMAJLINK @@@'

function print_ls {

#  format expecting variant versions like: /opt/hf/hf-8.18.1

	/bin/ls -ld --time-style=long-iso "$1" | awk '
{
	if (NF == 10) {
		printf "%s %s %s %-17s -> %s\n", $1, $6, $7, $8, $10
	} else {
		printf "%s %s %s                      %s\n", $1, $6, $7, $8
	}
}
'

}

DELETE=0
DELETE_LIST=''
if [ "${1:-}" = '-d' ]
then
	DELETE=1
	shift
fi

if [ ! -d $HFPREFIX ]
then
	echo "FATAL no install dir '$HFPREFIX'" 1>&2
	CLEANEXIT=1
	exit 1
fi

if [ ! -L $HFMAJTOP ]
then
	echo "FATAL no symlink '$HFMAJTOP'" 1>&2
	CLEANEXIT=1
	exit 1
fi

LASTSYM='no-such-file-by-this-name'
for i in `/bin/ls -1d --sort=version $HFPREFIX/*`
do
	if [ ! \( -d "$i" -o -L "$i" \) ]
	then
		echo "FATAL not a dir or symlink '$i'" 1>&2
		CLEANEXIT=1
		exit 1
	fi

	LEGEND="        "
	if [ -L "$i" ]
	then
		LEGEND="symlink "
		LASTSYM="$i"
	elif [ "$i" -ef "$LASTSYM" ]
	then
		LEGEND=" target "
	elif [ `/bin/ls -ld "$i" | awk '{print $1}'` = 'drwxr-xr-x' ]
	then
		LEGEND="   save "
	elif [ $DELETE -eq 1 ]
	then
		LEGEND=" DELETE "
		DELETE_LIST+=" $i"
	fi
	echo -n "$LEGEND "
	print_ls "$i"
done

if [ \( $DELETE -eq 1 \) -a \( -n "$DELETE_LIST" \) ]
then
	rm -r $DELETE_LIST
fi
