#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

use Data::Dumper;

$HF::Globals::verbosity = 3;

# -----

if ($#ARGV == -1) {
	&print_version;
	warn ("\n");
	&print_usage;
	exit (0);
}

my $cmd;

$cmd = shift (@ARGV);

if ($cmd eq 'host') {
	&do_host;
} elsif ($cmd eq 'eval') {
	&do_eval;
} else {
	&print_usage;
	exit (1);
}

# -----

sub do_host {

	my $i;

	print q@# Generated by hfhosts @ . join (' ', @ARGV) . q@

{
    'hosts' => [
@;
	foreach $i (@ARGV) {
		if ($i eq '_fork') {
			print q@        {
            'channel' => 'fork'
        },
@;
		} elsif ($i eq '_null') {
			print q@        {
            'channel' => 'null'
        },
@;
		} else {
			print q@        {
            'channel' => 'ssh',
            'hostname' => '@ . $i . q@',
###         'ip' => '127.0.0.1',
###         'sshopts' => [ '-p', '12345' ]
        },
@;
		}
	}

print q@    ]
}
@;

	exit (0);
}

sub do_eval {

	my $layersfile = shift (@ARGV);

	my $dumper;

	if ($layersfile eq '') {
		$layersfile = '-';
	}

	&HF::Hosts::eval_file_to_tmp ($layersfile);

	$dumper = Data::Dumper->new ([ $HF::Tmp::hosts ]);
	$dumper->Terse (1);

	print ($dumper->Dump);

	exit (0);
}
