#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

hf_MODULES := \
	hf/HF/Encode.pm \
	hf/HF/FTGroveler.pm \
	hf/HF/FTWstream.pm \
	hf/HF/GLOBstream.pm \
	hf/HF/NULLstream.pm \
	hf/HF/Harmonize.pm \
	hf/HF/HF.pm \
	hf/HF/Hosts.pm \
	hf/HF/Layers.pm \
	hf/HF/Local.pm \
	hf/HF/Marshal.pm \
	hf/HF/Misc.pm \
	hf/HF/Popen2way.pm \
	hf/HF/Remote.pm \
	hf/HF/Report.pm \
	hf/HF/Statreport.pm \
	hf/HF/STLstream.pm

hf_EXT_SH := \
	hf/coprocess.sh \
	hf/hf-bootstrap-pull-hfdist.sh \
	hf/hf-bootstrap-pull-tar.sh \
	hf/hf-bootstrap-push-bash.sh \
	hf/hf-bootstrap-push-hfdist-hfhosts.sh \
	hf/hf-bootstrap-push-hfdist-oe-int.sh \
	hf/hf-bootstrap-push-hfdist-oe.sh \
	hf/hf-bootstrap-push-hfdist-test.sh \
	hf/hf-bootstrap-push-hfdist.sh \
	hf/hf-bootstrap-push-rdist.sh \
	hf/hf-bootstrap-push-rsync.sh \
	hf/hf-bootstrap-push-scp.sh \
	hf/hf-bootstrap-push-tar.sh \
	hf/hf-root.sh \
	hf/hf-version.sh \
	hf/hf-winnow-versions.sh \
	hf/hfdist-oe.sh \
	hf/hfdu.sh \
	hf/sl-diff.sh \
	hf/sl-sum.sh \
	hf/sll.sh

hf_INT_PL := \
	hf/portallocate.pl

hf_EXT_PL := \
	hf/hf-decode.pl \
	hf/hf-encode.pl \
	hf/hf-remote-status.pl \
	hf/hfdist.pl \
	hf/hfhosts.pl \
	hf/hflayers.pl \
	hf/hflog.pl \
	hf/sl.pl

hf_INT_POD := \
	$(patsubst %.pl,%.pod,$(hf_INT_PL))

hf_EXT_POD := \
	$(patsubst %.sh,%.pod,$(hf_EXT_SH)) \
	$(patsubst %.pl,%.pod,$(hf_EXT_PL)) \
	hf/hf.pod

hf_FIVE_POD := \
	hf/hfhosts.5pod \
	hf/hflayers.5pod \
	hf/sl.5pod

hf_HELP := \
	hf/coprocess.help \
	hf/hf-bootstrap-pull-hfdist.help \
	hf/hf-bootstrap-pull-tar.help \
	hf/hf-bootstrap-push-bash.help \
	hf/hf-bootstrap-push-hfdist-hfhosts.help \
	hf/hf-bootstrap-push-hfdist-oe-int.help \
	hf/hf-bootstrap-push-hfdist-oe.help \
	hf/hf-bootstrap-push-hfdist-test.help \
	hf/hf-bootstrap-push-hfdist.help \
	hf/hf-bootstrap-push-rdist.help \
	hf/hf-bootstrap-push-rsync.help \
	hf/hf-bootstrap-push-scp.help \
	hf/hf-bootstrap-push-tar.help \
	hf/hf-decode.help \
	hf/hf-encode.help \
	hf/hf-remote-status.help \
	hf/hfdist.help \
	hf/hfdist-oe.help \
	hf/hfhosts.help \
	hf/hflayers.help \
	hf/hflog.help \
	hf/sl.help \
	hf/sll.help \
	hf/sl-diff.help \
	hf/sl-sum.help

hf_OTHERS := \
	hf/GNUmakefile \
	hf/bottom.pl \
	hf/bottom.sh \
	hf/data.pl.virgin \
	hf/hf-bottom.pod \
	hf/hf-bottom.sh \
	hf/hf-top.pod \
	hf/hf-top.sh \
	hf/module.mk \
	hf/top.pl \
	hf/top.sh

hf_SOURCES := \
	$(hf_MODULES) \
	$(hf_EXT_SH) \
	$(hf_INT_PL) \
	$(hf_EXT_PL) \
	$(hf_INT_POD) \
	$(filter-out hf/hf.pod,$(hf_EXT_POD)) \
	$(hf_FIVE_POD) \
	$(hf_HELP) \
	$(hf_OTHERS)

hf_MAN_ONE := \
	$(patsubst %.pod,%.1,$(hf_EXT_POD))

hf_MAN_FIVE := \
	$(patsubst %.5pod,%.5,$(hf_FIVE_POD))

hf_PERL_TESTME :=

hf_PERL_TESTME :=

hf_BASH_RESULTS := \
	hf/coprocess \
	hf/hf \
	hf/hf-bootstrap-pull-hfdist \
	hf/hf-bootstrap-pull-tar \
	hf/hf-bootstrap-push-bash \
	hf/hf-bootstrap-push-hfdist \
	hf/hf-bootstrap-push-hfdist-hfhosts \
	hf/hf-bootstrap-push-hfdist-oe \
	hf/hf-bootstrap-push-hfdist-oe-int \
	hf/hf-bootstrap-push-hfdist-test \
	hf/hf-bootstrap-push-rdist \
	hf/hf-bootstrap-push-rsync \
	hf/hf-bootstrap-push-scp \
	hf/hf-bootstrap-push-tar \
	hf/hf-root \
	hf/hf-version \
	hf/hf-winnow-versions \
	hf/hfdist-oe \
	hf/hfdu \
	hf/sl-diff \
	hf/sl-sum \
	hf/sll

hf_PERL_RESULTS := \
	hf/hf-decode \
	hf/hf-encode \
	hf/hf-remote-status \
	hf/hfdist \
	hf/hfhosts \
	hf/hflayers \
	hf/hflog \
	hf/portallocate \
	hf/sl

hf_RESULTS := \
	$(hf_BASH_RESULTS) \
	$(hf_PERL_RESULTS) \
	hf/hf.pod \
	hf/hf.sh \
	hf/hgrevid-d.out \
	hf/hgrevid.out \
	$(hf_MAN_FIVE) \
	$(hf_MAN_ONE)

# Dependencies deliberately hidden.  make install will install
# repeatedly using old md5 values.  make clean will update md5 values.
hf/md5:
	cat $(hf_SOURCES) | md5sum | awk '{print $$1}' > hf/md5

hf/hgrevid.out: bin/hgrevid
	bin/hgrevid > hf/hgrevid.out || :

hf/hgrevid-d.out: bin/hgrevid
	bin/hgrevid -d > hf/hgrevid-d.out || :

hf/coprocess: hf/coprocess.help

hf/hf-bootstrap-pull-hfdist: hf/hf-bootstrap-pull-hfdist.help

hf/hf-bootstrap-pull-tar: hf/hf-bootstrap-pull-tar.help

hf/hf-bootstrap-push-bash: hf/hf-bootstrap-push-bash.help

hf/hf-bootstrap-push-hfdist: hf/hf-bootstrap-push-hfdist.help

hf/hf-bootstrap-push-hfdist-hfhosts: hf/hf-bootstrap-push-hfdist-hfhosts.help

hf/hf-bootstrap-push-hfdist-oe: hf/hf-bootstrap-push-hfdist-oe.help

hf/hf-bootstrap-push-hfdist-oe-int: hf/hf-bootstrap-push-hfdist-oe-int.help

hf/hf-bootstrap-push-hfdist-test: hf/hf-bootstrap-push-hfdist-test.help

hf/hf-bootstrap-push-rdist: hf/hf-bootstrap-push-rdist.help

hf/hf-bootstrap-push-rsync: hf/hf-bootstrap-push-rsync.help

hf/hf-bootstrap-push-scp: hf/hf-bootstrap-push-scp.help

hf/hf-bootstrap-push-tar: hf/hf-bootstrap-push-tar.help

hf/hf-decode: hf/hf-decode.help

hf/hf-encode: hf/hf-encode.help

hf/hfdist: hf/hfdist.help

hf/hfdist-oe: hf/hfdist-oe.help

hf/hfdu: hf/hfdu.help

hf/hfhosts: hf/hfhosts.help

hf/hf-remote-status: hf/hf-remote-status.help

hf/hflayers: hf/hflayers.help

hf/hflog: hf/hflog.help

hf/sl: hf/sl.help

hf/sll: hf/sll.help

hf/sl-sum: hf/sl-diff.help

hf/sl-sum: hf/sl-sum.help

hf/hf.sh: hf/hf-top.sh tex/elevator.sh hf/hf-bottom.sh
	cat hf/hf-top.sh > hf/hf.sh
	fmt tex/elevator.sh >> hf/hf.sh
	cat hf/hf-bottom.sh >> hf/hf.sh

hf/hf.pod: hf/hf-top.pod tex/elevator.sh hf/hf-bottom.pod
	cat hf/hf-top.pod tex/elevator.sh hf/hf-bottom.pod > hf/hf.pod

.PHONY: build_hf
build_hf: $(hf_RESULTS) hf/md5

.PHONY: clean_hf
clean_hf: ## Clean hf
	rm -f $(strip $(hf_RESULTS) hf/print.ps hf/md5)

.PHONY: install_hf
install_hf: installstep1 $(hf_RESULTS) hf/md5 ## Install hf
	cp -a hf/coprocess install/$(HFTOP)/bin/coprocess
	cp -a hf/hf install/$(HFTOP)/bin/hf
	cp -a hf/hf-bootstrap-pull-hfdist install/$(HFTOP)/bin/hf-bootstrap-pull-hfdist
	cp -a hf/hf-bootstrap-pull-tar install/$(HFTOP)/bin/hf-bootstrap-pull-tar
	cp -a hf/hf-bootstrap-push-bash install/$(HFTOP)/bin/hf-bootstrap-push-bash
	cp -a hf/hf-bootstrap-push-hfdist install/$(HFTOP)/bin/hf-bootstrap-push-hfdist
	cp -a hf/hf-bootstrap-push-hfdist-hfhosts install/$(HFTOP)/bin/hf-bootstrap-push-hfdist-hfhosts
	cp -a hf/hf-bootstrap-push-hfdist-oe install/$(HFTOP)/bin/hf-bootstrap-push-hfdist-oe
	cp -a hf/hf-bootstrap-push-hfdist-oe-int install/$(HFTOP)/bin/hf-bootstrap-push-hfdist-oe-int
	cp -a hf/hf-bootstrap-push-hfdist-test install/$(HFTOP)/bin/hf-bootstrap-push-hfdist-test
	cp -a hf/hf-bootstrap-push-rdist install/$(HFTOP)/bin/hf-bootstrap-push-rdist
	cp -a hf/hf-bootstrap-push-rsync install/$(HFTOP)/bin/hf-bootstrap-push-rsync
	cp -a hf/hf-bootstrap-push-scp install/$(HFTOP)/bin/hf-bootstrap-push-scp
	cp -a hf/hf-bootstrap-push-tar install/$(HFTOP)/bin/hf-bootstrap-push-tar
	cp -a hf/hf-decode install/$(HFTOP)/bin/hf-decode
	cp -a hf/hf-encode install/$(HFTOP)/bin/hf-encode
	cp -a hf/hf-remote-status install/$(HFTOP)/bin/hf-remote-status
	cp -a hf/hf-root install/$(HFTOP)/bin/hf-root
	cp -a hf/hf-version install/$(HFTOP)/bin/hf-version
	cp -a hf/hf-winnow-versions install/$(HFTOP)/bin/hf-winnow-versions
	cp -a hf/hfdist install/$(HFTOP)/bin/hfdist
	cp -a hf/hfdist-oe install/$(HFTOP)/bin/hfdist-oe
	cp -a hf/hfdu install/$(HFTOP)/bin/hfdu
	cp -a hf/hfhosts install/$(HFTOP)/bin/hfhosts
	cp -a hf/hflayers install/$(HFTOP)/bin/hflayers
	cp -a hf/hflog install/$(HFTOP)/bin/hflog
	cp -a hf/sl install/$(HFTOP)/bin/sl
	cp -a hf/sll install/$(HFTOP)/bin/sll
	cp -a hf/sl-diff install/$(HFTOP)/bin/sl-diff
	cp -a hf/sl-sum install/$(HFTOP)/bin/sl-sum
	cp -a $(hf_MODULES) install/$(HFTOP)/lib/HF
	cp -a $(hf_MAN_ONE) install/$(HFTOP)/man/man1
	cp -a $(hf_MAN_FIVE) install/$(HFTOP)/man/man5

.PHONY: print_hf
print_hf: ## Print some files in hf
	enscript -f Courier7 -r -C -s 4 --mark-wrapped-lines=box -o hf/print.ps hf/HF/Harmonize.pm
