#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

use Data::Dumper;

if ($#ARGV != 2) {
	die "Usage: portallocate hfprefix perlprefix mysqlprefix\n";
}

my $paprefix = '/@@@ PORTALLOCATE TOP @@@';
my $port;
my $data;

&readdatabase;
if (($port = &findport (@ARGV)) == -1) {
	$port = &assignport (@ARGV);
	&writedatabase;
}
print "$port\n";

exit (0);

sub readdatabase {

	my $wholefile;

	open (DB, '<', "$paprefix/share/data.pl") || die "$!";
	{
		local ($/);
		undef ($/);
		$wholefile = <DB>;
	}
	close (DB) || die "$!";

	eval ($wholefile);
}

sub findport {

	my @prefixes = @_;

	my $value;
	my $i;

	$value = join ('&', @prefixes);

	foreach $i (grep (!/^unassigned_ports$/, keys (%{$data}))) {
		if ($data->{$i} eq $value) {
#			warn "port already allocated\n";
			return ($i);
		}
	}
#	warn "no port allocated\n";
	return (-1);
}

sub assignport {

	my @prefixes = @_;

	my $i;

	foreach $i (eval ($data->{'unassigned_ports'})) {
		if (!(exists ($data->{$i}))) {
#			warn "assigning new port\n";
			$data->{$i} = join ('&', @prefixes);
			return ($i);
		}
	}

	die "NO MORE PORTS LEFT TO ASSIGN";
}

sub writedatabase {

	my $dumper;

	open (DB, '>', "$paprefix/share/data.pl.new") || die "$!";

	$dumper = Data::Dumper->new ([$data], ['data']);
	print DB $dumper->Dump;

	close (DB) || die "$!";

	rename ("$paprefix/share/data.pl.new",
		"$paprefix/share/data.pl") || die "$!";
}
