#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

hfcompose_EXT_PL := \
	hfcompose/hfcompose.pl

hfcompose_EXT_POD := \
	$(patsubst %.pl,%.pod,$(hfcompose_EXT_PL))

hfcompose_FIVE_POD := \
	hfcompose/hfcompose.5pod

hfcompose_HELP := \
	hfcompose/hfcompose.help

hfcompose_OTHERS := \
	hfcompose/GNUmakefile \
	hfcompose/module.mk

hfcompose_SOURCES := \
	$(hfcompose_EXT_PL) \
	$(hfcompose_EXT_POD) \
	$(hfcompose_FIVE_POD) \
	$(hfcompose_HELP) \
	$(hfcompose_OTHERS)

hfcompose_MAN_ONE := \
	$(patsubst %.pod,%.1,$(hfcompose_EXT_POD))

hfcompose_MAN_FIVE := \
	$(patsubst %.5pod,%.5,$(hfcompose_FIVE_POD))

hfcompose_PERL_RESULTS := \
	hfcompose/hfcompose

hfcompose_RESULTS := \
	$(hfcompose_PERL_RESULTS) \
	$(hfcompose_MAN_FIVE) \
	$(hfcompose_MAN_ONE)

# Dependencies deliberately hidden.  make install will install
# repeatedly using old md5 values.  make clean will update md5 values.
hfcompose/md5:
	cat $(hfcompose_SOURCES) | md5sum | awk '{print $$1}' > hfcompose/md5

hfcompose/hfcompose: hfcompose/hfcompose.help

.PHONY: build_hfcompose
build_hfcompose: $(hfcompose_RESULTS) hfcompose/md5

.PHONY: clean_hfcompose
clean_hfcompose: ## Clean hfcompose
	rm -rf $(strip $(hfcompose_RESULTS) hfcompose/t_* hfcompose/md5)

.PHONY: install_hfcompose
install_hfcompose: installstep1 $(hfcompose_RESULTS) hfcompose/md5 ## Install hfcompose
	cp -a hfcompose/hfcompose install/$(HFTOP)/bin/hfcompose
	cp -a $(hfcompose_MAN_ONE) install/$(HFTOP)/man/man1
	cp -a $(hfcompose_MAN_FIVE) install/$(HFTOP)/man/man5
