#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

._SOURCES := \
	BUILD \
	configure \
	COPYING \
	GNUmakefile \
	INSTALL \
	module.mk \
	PREBUILD/Ubuntu_12.04.sh \
	PROBLEMS \
	README

._BASH_RESULTS :=

._PERL_RESULTS :=

._RESULTS := \
	$(._BASH_RESULTS) \
	$(._PERL_RESULTS)

COMPONENTMD5S := $(patsubst %,%/md5,$(filter-out .,$(CHUNKS)))

# Dependencies deliberately hidden.  make install will install
# repeatedly using old md5 values.  make clean will update md5 values.
md5: $(COMPONENTMD5S)
	cat $(._SOURCES) $(COMPONENTMD5S) | md5sum | awk '{print $$1}' > md5

.PHONY: build_.
build_.: $(._RESULTS) md5 ## Build top level dir

.PHONY: clean_.
clean_.: ## Clean top level dir
	rm -rf $(strip $(._RESULTS) install dist md5 md5.mk config.status)

.PHONY: install_.
install_.: installstep1 $(._RESULTS) md5 ## Install top level dir
