#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

omar_SH := \
	omar/oh-bottom.sh \
	omar/oh-top.sh

omar_EXT_PL := \
	omar/oh-blocked-commit.pl \
	omar/omar.pl

omar_EXT_POD := \
	$(patsubst %.pl,%.pod,$(omar_EXT_PL)) \
	omar/oh.pod

omar_HELP := \
	omar/oh.help \
	omar/omar.help

omar_OTHERS := \
	omar/module.mk \
	omar/GNUmakefile \

omar_SOURCES := \
	$(omar_SH) \
	$(omar_EXT_PL) \
	$(omar_EXT_POD) \
	$(omar_HELP) \
	$(omar_OTHERS)

omar_MAN := \
	$(patsubst %.pod,%.1,$(omar_EXT_POD))

omar_BASH_TESTME :=

omar_PERL_TESTME :=

omar_BASH_RESULTS := \
	omar/oh

omar_PERL_RESULTS := \
	omar/oh-blocked-commit \
	omar/omar

omar_RESULTS := \
	$(omar_BASH_RESULTS) \
	$(omar_PERL_RESULTS) \
	$(omar_MAN)

# Dependencies deliberately hidden.  make install will install
# repeatedly using old md5 values.  make clean will update md5 values.
omar/md5:
	cat $(omar_SOURCES) | md5sum | awk '{print $$1}' > omar/md5

omar/omar: omar/omar.pl
	sed -e "s|@@@ HFVER @@@|$(HFVER)|g" \
		< omar/omar.pl > omar/omar
	echo -e '\n__END__' >> omar/omar
	cat omar/omar.pod >> omar/omar
	chmod +x omar/omar

omar/oh: omar/oh-top.sh tex/runoutput/oh-doc.sh omar/oh-bottom.sh
	cat omar/oh-top.sh tex/runoutput/oh-doc.sh > omar/oh
	sed -e "s|@@@ HFTOP @@@|$(HFTOP)|g" \
		-e "s|@@@ HFVER @@@|$(HFVER)|g" \
		< omar/oh-bottom.sh >> omar/oh
	echo -e '\n:<<=cut' >> omar/oh
	cat omar/oh.pod >> omar/oh
	chmod +x omar/oh

omar/oh-blocked-commit: omar/oh-blocked-commit.pl
	sed -e "s|@@@ HFVER @@@|$(HFVER)|g" \
		< omar/oh-blocked-commit.pl > omar/oh-blocked-commit
	echo -e '\n__END__' >> omar/oh-blocked-commit
	cat omar/oh-blocked-commit.pod >> omar/oh-blocked-commit
	chmod +x omar/oh-blocked-commit

.PHONY: build_omar
build_omar: $(omar_RESULTS) omar/md5 ## Build omar

.PHONY: clean_omar
clean_omar: ## Clean omar
	rm -f $(omar_RESULTS) omar/md5

.PHONY: install_omar
install_omar: installstep1 $(omar_RESULTS) omar/md5 ## Install omar
	cp -a omar/omar install/$(HFTOP)/bin/omar
	cp -a omar/oh install/$(HFTOP)/bin/oh
	cp -a omar/oh-blocked-commit install/$(HFTOP)/bin/oh-blocked-commit
	cp -a $(omar_MAN) install/$(HFTOP)/man/man1
