#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

oneach_EXT_SH := \
	oneach/oe-demo.sh \
	oneach/oe-demo-logout.sh \
	oneach/oe-demo-w.sh \
	oneach/oewatch.sh

oneach_EXT_PL := \
	oneach/oel.pl \
	oneach/oe.pl

oneach_EXT_POD := \
	$(patsubst %.sh,%.pod,$(oneach_EXT_SH)) \
	$(patsubst %.pl,%.pod,$(oneach_EXT_PL))

oneach_HELP := \
	oneach/oe.help \
	oneach/oel.help \
	oneach/oewatch.help

oneach_OTHERS := \
	oneach/GNUmakefile \
	oneach/module.mk

oneach_SOURCES := \
	$(oneach_EXT_SH) \
	$(oneach_EXT_PL) \
	$(oneach_EXT_POD) \
	$(oneach_HELP) \
	$(oneach_OTHERS)

oneach_MAN := \
	$(patsubst %.pod,%.1,$(oneach_EXT_POD))

oneach_BASH_TESTME :=

oneach_PERL_TESTME :=

oneach_BASH_RESULTS := \
	oneach/oe-demo \
	oneach/oe-demo-logout \
	oneach/oe-demo-w \
	oneach/oewatch

oneach_PERL_RESULTS := \
	oneach/oe \
	oneach/oel

oneach_RESULTS := \
	$(oneach_BASH_RESULTS) \
	$(oneach_PERL_RESULTS) \
	$(oneach_MAN)

# Dependencies deliberately hidden.  make install will install
# repeatedly using old md5 values.  make clean will update md5 values.
oneach/md5:
	cat $(oneach_SOURCES) | md5sum | awk '{print $$1}' > oneach/md5

oneach/oe: oneach/oe.help

oneach/oel: oneach/oel.help

oneach/oewatch: oneach/oewatch.help

.PHONY: build_oneach
build_oneach: $(oneach_RESULTS) oneach/md5 ## Build oneach

.PHONY: clean_oneach
clean_oneach: ## Clean onach
	rm -f $(oneach_RESULTS) oneach/md5

.PHONY: install_oneach
install_oneach: installstep1 $(oneach_RESULTS) oneach/md5 ## Install oneach
	cp -a oneach/oe-demo install/$(HFTOP)/bin/oe-demo
	cp -a oneach/oe-demo-logout install/$(HFTOP)/bin/oe-demo-logout
	cp -a oneach/oe-demo-w install/$(HFTOP)/bin/oe-demo-w
	cp -a oneach/oe install/$(HFTOP)/bin/oe
	cp -a oneach/oel install/$(HFTOP)/bin/oel
	cp -a oneach/oewatch install/$(HFTOP)/bin/oewatch
	cp -a $(oneach_MAN) install/$(HFTOP)/man/man1
