#!/bin/bash -euET

#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

CLEANEXIT=0
trap '
SAVEDSTATUS=$?
set +x
if [ "${CLEANEXIT:-0}" -ne 1 ]
then
	echo "${0##*/}: FATAL Unexpected return value of ${SAVEDSTATUS:-?}, line number ${ERR_LINENO:-?}, quitting" 1>&2
	exit $SAVEDSTATUS
fi' EXIT

trap 'ERR_LINENO=$LINENO' ERR

set -o pipefail

#-----

HFGENDB=hfexample1 ./get-usernames.sh > out_get-usernames.tmp

# To make the example shorter
head -20 out_get-usernames.tmp > out_get-usernames

./add-passwords.pl < out_get-usernames

./password-cards.pl < out_add-passwords.tab > out_password-cards.tex

pdflatex out_password-cards.tex

rm out_add-passwords.sql out_add-passwords.tab out_get-usernames out_get-usernames.tmp out_password-cards.aux out_password-cards.log out_password-cards.tex

#-----

CLEANEXIT=1
exit 0
