#!/usr/bin/perl

#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

sub makeapassword {

	open (CMD, '<', "/dev/urandom") || die "$!";

	read (CMD, $stuff, 18) || die "$!";

###	# Show bits
###	print unpack ("b*", $stuff);
###	exit 0;

	$readable = '';
	for ($i = length ($stuff) - 2;  $i > 0;  $i -= 2) {
		$c = unpack ("C", substr ($stuff, $i, 2));
		$c = $c % 84;

		if (0 <= $c && $c <= 9) {
			$readable .= pack ("c", $c + 48);	# 0-9
		} elsif (10 <= $c && $c <= 35) {
			$readable .= pack ("c", $c + 55);	# A-Z
		} elsif (36 <= $c && $c <= 61) {
			$readable .= pack ("c", $c + 61);	# a-z
		} elsif ($c == 62) {
			$readable .= "@";			# @
		} elsif ($c == 63) {
			$readable .= "[";			# [
		} elsif ($c == 64) {
			$readable .= "]";			# ]
		} elsif ($c == 65) {
			$readable .= "!";			# !
		} elsif ($c == 66) {
			$readable .= "*";			# *
		} elsif ($c == 67) {
			$readable .= "+";			# +
		} elsif ($c == 68) {
			$readable .= ".";			# .
		} elsif ($c == 69) {
			$readable .= "/";			# /
		} elsif ($c == 70) {
			$readable .= ":";			# :
		} elsif ($c == 71) {
			$readable .= ";";			# ;
		} elsif ($c == 72) {
			$readable .= "=";			# =
		} elsif ($c == 73) {
			$readable .= "?";			# ?
		} elsif ($c == 74) {
			$readable .= "^";			# ^
		} elsif ($c == 75) {
			$readable .= ",";			# ,
		} elsif ($c == 76) {
			$readable .= "<";			# <
		} elsif ($c == 77) {
			$readable .= ">";			# >
		} elsif ($c == 78) {
			$readable .= "%";			# %
		} elsif ($c == 79) {
			$readable .= "&";			# &
		} elsif ($c == 80) {
			$readable .= "#";			# #
		} elsif ($c == 81) {
			$readable .= "(";			# (
		} elsif ($c == 82) {
			$readable .= ")";			# )
		} elsif ($c == 83) {
			$readable .= "{";			# {
		} elsif ($c == 84) {
			$readable .= "}";			# }
		} else {
			die "coding error";
		}
	}

	return ($readable);
}


sub alphadigitcount {

#  The first 6 characters of the password must contain at least two
#  alphabetic characters and at least one numerical or special
#  character.

	($inpasswd, $junk) = @_;

	$alphacount = 0;
	$digitcount = 0;
	$specialcount = 0;

	for ($i = 0;  $i < 6;  $i++) {

		$char = substr ($inpasswd, $i, 1);

		if ($char =~ /[a-zA-Z]/) {
			$alphacount++;
		} elsif ($char =~ /[0-9]/) {
			$digitcount++;
		} else {
			$specialcount++;
		}
	}

	if (($alphacount < 2) || (($digitcount + $specialcount) < 1)) {
		return (1);
	} else {
		return (0);
	}
}


sub docrypt {

	($inpass, $junk) = @_;

	$tempfile = "/tmp/add-passwords.$$";

	open (TMP, '>', $tempfile) || die "$!";
	close (TMP);
	chmod (0600, $tempfile) || die "$!";

	open (MKPASSWD, "| /usr/bin/mkpasswd -s -H md5 > $tempfile") || die "$!";
	print MKPASSWD "$inpass\n";
	close (MKPASSWD);

	open (TMP, '<', $tempfile) || die "$!";
	$cryptresults = <TMP>;
	chop ($cryptresults);
	close (TMP);

	unlink ($tempfile) || die "$!";

	return ($cryptresults);
}

open (SQLOUT, '>', 'out_add-passwords.sql') || die "$!";
open (TABOUT, '>', 'out_add-passwords.tab') || die "$!";

while (<>) {

	$line = $_;
	chop ($line);
	($username, $humanname, $junk) = split (/\t/, $line);

	do {
		$pass = &makeapassword;
	} until (($pass !~ /[01loIO]/) && (&alphadigitcount ($pass) == 0));

	$crypt = &docrypt ($pass);

	printf TABOUT ("%s\t%s\t%s\n", $username, $humanname, $pass);
	print SQLOUT "update usernames set cryptpw = '$crypt' where username = '$username';\n";
}

close (SQLOUT);
close (TABOUT);
