#!/bin/bash -euET

#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

CLEANEXIT=0
trap '
SAVEDSTATUS=$?
set +x
if [ "${CLEANEXIT:-0}" -ne 1 ]
then
	echo "${0##*/}: FATAL Unexpected return value of ${SAVEDSTATUS:-?}, line number ${ERR_LINENO:-?}, quitting" 1>&2
	exit $SAVEDSTATUS
fi' EXIT

trap 'ERR_LINENO=$LINENO' ERR

set -o pipefail

#-----

#
#  Usage:
#
#	HFGENDB=foo ./report-highestuidgid
#

: ${HFGENDB:?FATAL env var HFGENDB not defined, should be name of gen database, quitting}

mysql -t -uhfgen -p$(< ~/.hfgen-password) $HFGENDB << EOF
select gid as uidgid, 'groupnames' as source from groupnames
union
select uid as uidgid, 'usernames' from usernames
union
select gid as uidgid, 'groupnames' from usernames
order by uidgid desc, source desc limit 10;
EOF

#-----

CLEANEXIT=1
exit 0
