#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

rdb_RTABLES := \
	rdb/groupnames.rdb \
	rdb/hostids.rdb \
	rdb/hosts.rdb \
	rdb/ipallocs.rdb \
	rdb/ips.rdb \
	rdb/locs.rdb \
	rdb/occupants.rdb \
	rdb/persons.rdb \
	rdb/prns.rdb \
	rdb/secgroups.rdb \
	rdb/sites.rdb \
	rdb/usernames.rdb

rdb_OTHERS := \
	rdb/module.mk \
	rdb/GNUmakefile

rdb_SOURCES := \
	$(rdb_RTABLES) \
	$(rdb_OTHERS)

rdb_BASH_TESTME :=

rdb_PERL_TESTME :=

rdb_BASH_RESULTS :=

rdb_PERL_RESULTS :=

rdb_RESULTS := \
	$(rdb_BASH_RESULTS) \
	$(rdb_PERL_RESULTS) \
	$(patsubst %.rdb,%.sqlinsert,$(rdb_RTABLES))

rdb_TABLES := \
	$(patsubst %.rdb,%.sqlinsert,$(rdb_RTABLES))

# Dependencies deliberately hidden.  make install will install
# repeatedly using old md5 values.  make clean will update md5 values.
rdb/md5:
	cat $(rdb_SOURCES) | md5sum | awk '{print $$1}' > rdb/md5

%.sqlinsert: %.rdb bin/rowsqlinsert
	bin/rowsqlinsert $< > $@

.PHONY: build_rdb
build_rdb: $(rdb_RESULTS) rdb/md5 ## Build rdb

.PHONY: clean_rdb
clean_rdb: ## Clean rdb
	rm -f $(strip $(rdb_RESULTS) rdb/md5)

.PHONY: install_rdb
install_rdb: installstep1 $(rdb_RESULTS) rdb/md5 ## Install rdb

.PHONY: repair_rdb
repair_rdb: $(rdb_TABLES) ## Repair rdb file formats in rdb
	cd rdb ; for i in *.rdb ; do \
		repair -blank -exist $$i; \
		mv $$i.rdb $$i; \
	done
