#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

sql_SQL := \
	sql/hello.sql

sql_OTHERS := \
	sql/module.mk \
	sql/GNUmakefile

sql_SOURCES := \
	$(sql_SQL) \
	$(sql_OTHERS)

sql_BASH_TESTME :=

sql_PERL_TESTME :=

sql_BASH_RESULTS :=

sql_PERL_RESULTS :=

sql_RESULTS := \
	$(sql_BASH_RESULTS) \
	$(sql_PERL_RESULTS) \
	sql/ddl.sql \
	sql/dml.sql \
	sql/load.sql

# Dependencies deliberately hidden.  make install will install
# repeatedly using old md5 values.  make clean will update md5 values.
sql/md5:
	cat $(sql_SOURCES) | md5sum | awk '{print $$1}' > sql/md5

# XXX running this multiple times is less awful than not running it enough.
# XXX a pattern rule with multiple targets as for bison may fix this problem.
sql/ddl.sql tex/ddl.tex tex/schema.dot tex/tables.tex db/HF/Schema.pm: $(tbl_TABLES) bin/tblburst
	bin/tblburst -d mysql5 $(tbl_TABLES) 1> sql/ddl.sql 3> tex/ddl.tex 4> tex/schema.dot 5> tex/tables.tex 6> db/HF/Schema.pm

# XXX running this multiple times is less awful than not running it enough.
# XXX a pattern rule with multiple targets as for bison may fix this problem.
sql/dml.sql tex/dml.tex: $(sql_SQL) bin/sqlburst
	bin/sqlburst $(sql_SQL) 1> sql/dml.sql 3> tex/dml.tex

# XXX shouldn't load.sql be dml.sql?
sql/load.sql: sql/ddl.sql $(rdb_RESULTS)
	echo '--' > sql/load.sql
	echo '--  Mechanically generated, edits will be lost' >> sql/load.sql
	echo '--' >> sql/load.sql
	echo '' >> sql/load.sql
	for i in $(strip $(rdb_RESULTS)) ; do cat $$i >> sql/load.sql ; echo 'commit;' >> sql/load.sql ; done

.PHONY: build_sql
build_sql: $(sql_RESULTS) sql/md5 ## Build sql

.PHONY: clean_sql
clean_sql: ## Clean sql
	rm -f $(strip $(sql_RESULTS) tex/schema.dot tex/ddl.tex tex/dml.tex tex/tables.tex sql/load.out db/HF/Schema.pm sql/md5)

.PHONY: install_sql
install_sql: installstep1 $(sql_RESULTS) sql/md5 ## Install sql
	cp -a sql/ddl.sql install/$(HFTOP)/lib/ddl.sql
	cp -a sql/load.sql install/$(HFTOP)/lib/load.sql
	cp -a db/HF/Schema.pm install/$(HFTOP)/lib/HF/Schema.pm
