#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

svg_SVGES := \
	svg/dataflow-all.svg \
	svg/dataflow-collect.svg \
	svg/dataflow-dist.svg \
	svg/dataflow-gen.svg \
	svg/dataflow-master.svg \
	svg/dataflow-update.svg \
	svg/factory.svg \
	svg/layers-103-inv.svg \
	svg/layers-103.svg \
	svg/layers-parts.svg \
	svg/layers-stack.svg \
	svg/layers-terms.svg \
	svg/leadership-triangle.svg \
	svg/product-venn.svg \
	svg/wv-sm.svg

svg_OTHERS := \
	svg/GNUmakefile \
	svg/module.mk \
	svg/Notes \
	svg/swiss-army-knife.jpg

svg_SOURCES := \
	$(svg_SVGES) \
	$(svg_OTHERS)

svg_BASH_TESTME :=

svg_PERL_TESTME :=

svg_BASH_RESULTS :=

svg_PERL_RESULTS :=

svg_RESULTS := \
	$(svg_BASH_RESULTS) \
	$(svg_PERL_RESULTS) \
	$(patsubst %.svg,%.pdf,$(svg_SVGES)) \
	$(patsubst %.svg,%.eps,$(svg_SVGES)) \
	svg/swiss-army-knife.ps

# Dependencies deliberately hidden.  make install will install
# repeatedly using old md5 values.  make clean will update md5 values.
svg/md5:
	cat $(svg_SOURCES) | md5sum | awk '{print $$1}' > svg/md5

.PHONY: build_svg
build_svg: $(svg_RESULTS) svg/md5 ## Build svg

.PHONY: clean_svg
clean_svg: ## Clean svg
	rm -f $(strip $(svg_RESULTS) svg/md5)

.PHONY: install_svg
install_svg: installstep1 $(svg_RESULTS) svg/md5 ## Install svg
