#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

tbl_RTABLES := \
	tbl/groupnames.rtbl  \
	tbl/hostkinds.rtbl \
	tbl/hostids.rtbl \
	tbl/hosts.rtbl \
	tbl/ipallocs.rtbl \
	tbl/ips.rtbl \
	tbl/locs.rtbl \
	tbl/occupants.rtbl \
	tbl/persons.rtbl \
	tbl/prnkinds.rtbl \
	tbl/prns.rtbl \
	tbl/secgroups.rtbl \
	tbl/sites.rtbl \
	tbl/usernames.rtbl

tbl_TYPES := \
	tbl/TYPES.rdb

tbl_OTHERS := \
	tbl/module.mk \
	tbl/GNUmakefile

tbl_SOURCES := \
	$(tbl_RTABLES) \
	$(tbl_OTHERS) \
	$(tbl_TYPES)

tbl_BASH_TESTME :=

tbl_PERL_TESTME :=

tbl_BASH_RESULTS :=

tbl_PERL_RESULTS :=

tbl_RESULTS := \
	$(tbl_BASH_RESULTS) \
	$(tbl_PERL_RESULTS) \
	$(patsubst %.rtbl,%.tbl,$(tbl_RTABLES)) tbl/TYPES.tex tbl/hosts.tex

tbl_TABLES := \
	$(patsubst %.rtbl,%.tbl,$(tbl_RTABLES))

# Dependencies deliberately hidden.  make install will install
# repeatedly using old md5 values.  make clean will update md5 values.
tbl/md5:
	cat $(tbl_SOURCES) | md5sum | awk '{print $$1}' > tbl/md5

%.tbl: %.rtbl tbl/TYPES.rdb bin/tbltypes
	bin/tbltypes tbl/TYPES.rdb < $< > $@

tbl/TYPES.tex: tbl/TYPES.rdb
	bin/ptbltex < tbl/TYPES.rdb > tbl/TYPES.tex

tbl/hosts.tex: tbl/hosts.rtbl
	bin/ptbltex < tbl/hosts.rtbl > tbl/hosts.tex

.PHONY: build_tbl
build_tbl: $(tbl_RESULTS) tbl/md5 ## Build tbl

.PHONY: clean_tbl
clean_tbl: ## Clean tbl
	rm -f $(strip $(tbl_RESULTS) tbl/md5)

.PHONY: install_tbl
install_tbl: installstep1 $(tbl_RESULTS) tbl/md5 ## Install tbl

.PHONY: repair_tbl
repair_tbl: $(tbl_TABLES) ## Repair rdb file formats in tbl
	cd tbl ; for i in *.rtbl ; do \
		repair -blank -exist $$i; \
		mv `basename $$i .rtbl`.rdb $$i; \
	done
	cd tbl ; repair -blank -exist TYPES.rdb ; mv TYPES.rdb.rdb TYPES.rdb
	cd tbl ; LC_ALL=C sorttbl type < TYPES.rdb > TYPES.$$$$ ; mv TYPES.$$$$ TYPES.rdb
