#!/usr/bin/perl

#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

#  Usage:
#
#	mkt_bridge 1|2
#

#--

if (($ARGV[0] ne '1') && ($ARGV[0] ne '2')) {
	die "Usage: $0 1|2\n";
}

(!(system ('rm', '-rf', 't_bridge') / 256)) || die "$!";
mkdir ('t_bridge', 0755) || die "$!";
chdir ('t_bridge') || die "$!";

mkdir ("source1", 0755) || die "$!";
mkdir ("source2", 0755) || die "$!";
mkdir ("source3", 0755) || die "$!";
mkdir ("source4", 0755) || die "$!";
mkdir ("source5", 0755) || die "$!";
mkdir ("target", 0755) || die "$!";

#--

#	                owner   group   mode          mtime       content symlink rdev
	&makeit ('d',   31,     31,     oct("755"),   1000000031, '',     '',     0,     "source1/dup-top");
	&makeit ('f',   34,     34,     oct("755"),   1000000034, 'mmm',  '',     0,     "source1/dup-top/foo-8");
	&makeit ('d',   32,     32,     oct("755"),   1000000032, '',     '',     0,     "source1/dup-top/dup-mid");
	&makeit ('f',   35,     35,     oct("755"),   1000000035, 'nnn',  '',     0,     "source1/dup-top/dup-mid/foo-9");
	&makeit ('d',   33,     33,     oct("755"),   1000000033, '',     '',     0,     "source1/dup-top/dup-mid/dup-low");
	&makeit ('d',   3,      3,      oct("755"),   1000000003, '',     '',     0,     "source1/foo-1");
	&makeit ('d',   4,      4,      oct("755"),   1000000004, '',     '',     0,     "source1/shadow-upper-dup");
	&makeit ('f',   5,      5,      oct("644"),   1000000005, 'jjj',  '',     0,     "source1/shadow-upper-dup/foo-5");
	&makeit ('d',   6,      6,      oct("755"),   1000000006, '',     '',     0,     "source1/shadow-upper-dup/shadow-lower-dup");
	&makeit ('d',   7,      7,      oct("755"),   1000000007, '',     '',     0,     "source1/shadow-upper-skip");
	&makeit ('f',   8,      8,      oct("644"),   1000000008, 'aaa',  '',     0,     "source1/shadow-upper-skip/foo-2");
	&makeit ('d',   9,      9,      oct("755"),   1000000009, '',     '',     0,     "source1/shadow-upper-skip/shadow-lower-skip");
	&makeit ('f',   11,     11,     oct("755"),   1000000011, 'bbb',  '',     0,     "source2/foo-3");
	&makeit ('f',   13,     13,     oct("755"),   1000000013, 'ccc',  '',     0,     "source3/foo-4");
	&makeit ('f',   28,     28,     oct("755"),   1000000028, 'kkk',  '',     0,     "source4/foo-6");
	&makeit ('f',   30,     30,     oct("755"),   1000000030, 'lll',  '',     0,     "source5/foo-7");
if ($ARGV[0] eq '2') {
	&makeit ('d',   37,     37,     oct("755"),   1000000037, '',     '',     0,     "target/dup-top");
	&makeit ('f',   38,     38,     oct("755"),   1000000038, 'ppp',  '',     0,     "target/dup-top/where-written-7");
	&makeit ('d',   39,     39,     oct("755"),   1000000039, '',     '',     0,     "target/dup-top/dup-mid");
	&makeit ('f',   40,     40,     oct("755"),   1000000040, 'qqq',  '',     0,     "target/dup-top/dup-mid/where-written-8");
	&makeit ('d',   41,     41,     oct("755"),   1000000041, '',     '',     0,     "target/dup-top/dup-mid/dup-low");
	&makeit ('f',   42,     42,     oct("755"),   1000000042, 'rrr',  '',     0,     "target/dup-top/dup-mid/dup-low/where-written-9");
	&makeit ('d',   15,     15,     oct("755"),   1000000015, '',     '',     0,     "target/shadow-upper");
	&makeit ('d',   16,     16,     oct("755"),   1000000016, '',     '',     0,     "target/shadow-upper/shadow-lower");
	&makeit ('f',   17,     17,     oct("644"),   1000000017, 'eee',  '',     0,     "target/shadow-upper/shadow-lower/where-written-2");
	&makeit ('f',   18,     18,     oct("644"),   1000000018, 'ddd',  '',     0,     "target/shadow-upper/where-written-1");
	&makeit ('d',   19,     19,     oct("755"),   1000000019, '',     '',     0,     "target/shadow-upper-dup");
	&makeit ('d',   20,     20,     oct("755"),   1000000020, '',     '',     0,     "target/shadow-upper-dup/shadow-lower-dup");
	&makeit ('f',   21,     21,     oct("644"),   1000000021, 'iii',  '',     0,     "target/shadow-upper-dup/shadow-lower-dup/where-written-6");
	&makeit ('f',   22,     22,     oct("644"),   1000000022, 'hhh',  '',     0,     "target/shadow-upper-dup/where-written-5");
	&makeit ('d',   23,     23,     oct("755"),   1000000023, '',     '',     0,     "target/shadow-upper-skip");
	&makeit ('d',   24,     24,     oct("755"),   1000000024, '',     '',     0,     "target/shadow-upper-skip/shadow-lower-skip");
	&makeit ('f',   25,     25,     oct("644"),   1000000025, 'ggg',  '',     0,     "target/shadow-upper-skip/shadow-lower-skip/where-written-4");
	&makeit ('f',   26,     26,     oct("644"),   1000000026, 'fff',  '',     0,     "target/shadow-upper-skip/where-written-3");
}

#--

utime (1000000007, 1000000007, "source1/shadow-upper-skip") || die "$!";
utime (1000000004, 1000000004, "source1/shadow-upper-dup") || die "$!";
utime (1000000033, 1000000033, "source1/dup-top/dup-mid/dup-low") || die "$!";
utime (1000000032, 1000000032, "source1/dup-top/dup-mid") || die "$!";
utime (1000000031, 1000000031, "source1/dup-top") || die "$!";
utime (1000000002, 1000000002, "source1") || die "$!";
utime (1000000010, 1000000010, "source2") || die "$!";
utime (1000000012, 1000000012, "source3") || die "$!";
utime (1000000027, 1000000027, "source4") || die "$!";
utime (1000000029, 1000000029, "source5") || die "$!";
if ($ARGV[0] eq '2') {
	utime (1000000037, 1000000037, "target/dup-top") || die "$!";
	utime (1000000039, 1000000039, "target/dup-top/dup-mid") || die "$!";
	utime (1000000041, 1000000041, "target/dup-top/dup-mid/dup-low") || die "$!";
	utime (1000000016, 1000000016, "target/shadow-upper/shadow-lower") || die "$!";
	utime (1000000015, 1000000015, "target/shadow-upper") || die "$!";
	utime (1000000024, 1000000024, "target/shadow-upper-skip/shadow-lower-skip") || die "$!";
	utime (1000000023, 1000000023, "target/shadow-upper-skip") || die "$!";
	utime (1000000020, 1000000020, "target/shadow-upper-dup/shadow-lower-dup") || die "$!";
	utime (1000000019, 1000000019, "target/shadow-upper-dup") || die "$!";
}
utime (1000000014, 1000000014, "target") || die "$!";
utime (1000000001, 1000000001, ".") || die "$!";

#--

exit (0);

#-----

sub chownifroot {

	my $owner = shift;
	my $group = shift;
	my $filename = shift;

	if ($> == 0) {
		chown ($owner, $group, $filename) || die "$!";
	}
}

sub utimeifroot {

	my $mtime = shift;
	my $name = shift;

	if ($> == 0) {
		utime ($mtime, $mtime, $name) || die "$!";
	}
}

sub chmodifroot {

	my $mode = shift;
	my $name = shift;

	if ($> == 0) {
		chmod ($mode, $name) || die "$!";
	}
}

sub touch {

	my $filename = shift;
	my $contents = shift;

	$filename =~ s#^(\s)#./$1#;
	open (TOUCH, '>', "$filename\0") || die "$!, filename $filename";
	if (defined ($contents)) {
		print TOUCH $contents;
	}
	close (TOUCH) || die "$!";
}

sub fakemakeit {

	warn join (', ', @_) . "\n";
}

sub makeit {

	my $type = shift;
	my $owner = shift;
	my $group = shift;
	my $mode = shift;
	my $mtime = shift;
	my $content = shift;
	my $symlinktarget = shift;
	my $rdev = shift;
	my $name = shift;

#	warn "sub makeit type $type name $name\n";

	if ($type eq "f") {
		&touch ($name, $content);
		&chownifroot ($owner, $group, $name);
		chmod ($mode, $name) || die "$!";
		utime ($mtime, $mtime, $name) || die "$!";
	} elsif ($type eq "d") {
		mkdir ($name, $mode) || die "name $name, error $!";
		&chownifroot ($owner, $group, $name);
		chmod ($mode, $name) || die "$!";
		utime ($mtime, $mtime, $name) || die "$!";
	} elsif ($type eq "s") {
		symlink ($symlinktarget, $name) || die "$!";
	} elsif ($type eq "p") {
		(!(system ('mkfifo', $name) / 256)) || die "$!";
		&chownifroot ($owner, $group, $name);
		chmod ($mode, $name) || die "$!";
		utime ($mtime, $mtime, $name) || die "$!";
	} elsif ($type eq "c") {
		&mknodifroot ($name, 'c', $rdev);
		&chownifroot ($owner, $group, $name);
		&chmodifroot ($mode, $name);
		&utimeifroot ($mtime, $name);
	} elsif ($type eq "b") {
		&mknodifroot ($name, 'b', $rdev);
		&chownifroot ($owner, $group, $name);
		&chmodifroot ($mode, $name);
		&utimeifroot ($mtime, $name);
	} elsif ($type eq "k") {
		&makesocket ($name);
		&chownifroot ($owner, $group, $name);
		chmod ($mode, $name) || die "$!";
		utime ($mtime, $mtime, $name) || die "$!";
	} else {
		die "unknown type $type";
	}
}
