
#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

sub chownifroot {

	my $owner = shift;
	my $group = shift;
	my $filename = shift;

	if ($> == 0) {
		return (chown ($owner, $group, $filename));
	} else {
		return (1);
	}
}

sub touch {

	$filename = shift;
	$contents = shift;

	$filename =~ s#^(\s)#./$1#;
	open (TOUCH, '>', "$filename\0") || die "$!, filename $filename";
	if (defined ($contents)) {
		print TOUCH $contents;
	}
	close (TOUCH) || die "$!";
	&chownifroot (0, 0, $filename) || die "$!";
	chmod (0644, $filename) || die "$!";
	utime (1000000000, 1000000000, $filename) || die "$!";
}

$totslots = 10;
$totfiles = 100;

#srand (999);

system ("rm -rf t_rand_hardlinks");
mkdir ("t_rand_hardlinks") || die "$!";
chdir ("t_rand_hardlinks") || die "$!";

for ($count = 0;  $count < 2;  $count++) {
	mkdir ($count) || die "$!";
	chdir ($count) || die "$!";
	$slots = undef;
	for ($i = 0;  $i < $totfiles;  $i++) {
		$slot = int ((rand() * $totslots) + 0.5);
		push (@{$slots->[$slot]}, "a$i");
	}
	for ($i = 0;  $i < $totslots;  $i++) {
		@thisnet = @{$slots->[$i]};
		if ($#thisnet > -1) {	# rand may not have hit this slot
			print "$count/$i: " . join (', ', @thisnet) . "\n";
			$head = shift (@thisnet);
			&touch ($head);
			foreach $j (@thisnet) {	# may not be any
				link ($head, $j) || die "$!";
			}
		}
	}
	print "\n";
	chdir ("..") || die "$!";
	utime (1000000000, 1000000000, $count) || die "$!";
}

chdir ("..") || die "$!";
utime (1000000000, 1000000000, "t_rand_hardlinks") || die "$!";
