#!/usr/bin/perl

#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

#  Usage:
#
#	mkt_treat_3
#
#	[forward test dist]
#	[reverse test dist]

use Socket;
use Carp;

#--

(!(system ('rm', '-rf', 't_treat_3') / 256)) || die "$!";
mkdir ('t_treat_3', 0755) || die "$!";
chdir ('t_treat_3') || die "$!";

mkdir ("source") || die "$!";
mkdir ("target") || die "$!";
mkdir ("target_right") || die "$!";

mkdir ("source_sr") || die "$!";
mkdir ("target_sr") || die "$!";
mkdir ("source_sr_right") || die "$!";

mkdir ("source_alt") || die "$!";

mkdir ("source_alt_sr") || die "$!";
mkdir ("source_alt_sr_right") || die "$!";

$n = 0;

#--

sub mkdir_top {

	my $treatment = shift;

	mkdir ("source/$treatment") || die "$!";
	mkdir ("target/$treatment") || die "$!";
	mkdir ("target_right/$treatment") || die "$!";

	mkdir ("source_sr/$treatment") || die "$!";
	mkdir ("target_sr/$treatment") || die "$!";
	mkdir ("source_sr_right/$treatment") || die "$!";
}

sub utime_bottom {

	my $treatment = shift;

	utime (1000000000, 1000000000, "source/$treatment") || die "$!";
	utime (1000000000, 1000000000, "target/$treatment") || die "$!";
	utime (1000000000, 1000000000, "target_right/$treatment") || die "$!";

	utime (1000000000, 1000000000, "source_sr/$treatment") || die "$!";
	utime (1000000000, 1000000000, "target_sr/$treatment") || die "$!";
	utime (1000000000, 1000000000, "source_sr_right/$treatment") || die "$!";
}

sub mkdir_top_alt {

	my $treatment = shift;

	mkdir ("source_alt/$treatment") || die "$!";

	mkdir ("source_alt_sr/$treatment") || die "$!";
	mkdir ("source_alt_sr_right/$treatment") || die "$!";
}

sub utime_bottom_alt {

	my $treatment = shift;

	utime (1000000000, 1000000000, "source_alt/$treatment") || die "$!";

	utime (1000000000, 1000000000, "source_alt_sr/$treatment") || die "$!";
	utime (1000000000, 1000000000, "source_alt_sr_right/$treatment") || die "$!";
}

#--

$treatment = 0;

&mkdir_top ($treatment);

foreach $type ("f", "d", "s", "p", "c", "b", "k") {

	$name = "$type-$treatment";

	$A   = "00";
	$bb  = "11";
	$CCC = "22";

#	                owner   group   mode              mtime   content symlink rdev
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $A,     $A,     $A,    "source/$treatment/$name");
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    $bb,    $bb,    $bb,   "target/$treatment/$name");
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $A,     $A,     $A,    "target_right/$treatment/$name");

	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $A,     $A,     $A,    "source_sr/$treatment/$name-sr");
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    $bb,    $bb,    $bb,   "target_sr/$treatment/$name-sr");
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    $bb,    $bb,    $bb,   "source_sr_right/$treatment/$name-sr");
}

&utime_bottom ($treatment);

#--

$treatment = 101;

if (1) {

&mkdir_top ($treatment);

foreach $type ("f", "d", "s", "p", "c", "b", "k") {

	$name = "$type";

	$A   = "00";
	$bb  = "11";
	$CCC = "22";

#	                owner   group   mode              mtime   content symlink rdev
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $A,     $A,     $A,    "source/$treatment/$name");
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    $bb,    $bb,    $bb,   "target/$treatment/$name");
if (($type eq "f") || ($type eq "b") || ($type eq "c")) {
# updates og to match source because target remade for contents
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $A,     $A,     $A,    "target_right/$treatment/$name");
} else {
# does not update og to match source because target not remade for contents
	&makeit ($type, $bb,    $bb,    oct("007".$A  ),  $A,     999,    $A,     999,   "target_right/$treatment/$name");
}

	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $A,     $A,     $A,    "source_sr/$treatment/$name-sr");
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    $bb,    $bb,    $bb,   "target_sr/$treatment/$name-sr");
if (($type eq "f") || ($type eq "b") || ($type eq "c")) {
# updates og to match source because target remade for contents
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    $bb,    $bb,    $bb,   "source_sr_right/$treatment/$name-sr");
} else {
# does not update og to match source because target not remade for contents
	&makeit ($type, $A,     $A,     oct("007".$bb ),  $bb,    999,    $bb,    999,   "source_sr_right/$treatment/$name-sr");
}

}

$type = "f";
$name = "$type-$treatment-m-change-og-differ";

	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $A,     $A,     $A,    "source/$treatment/$name");
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $A,     $A,     $A,     $A,    "target/$treatment/$name");
# does not update og to match source because target contents not rewritten
	&makeit ($type, $bb,    $bb,    oct("007".$A  ),  $A,     $A,     $A,     $A,    "target_right/$treatment/$name");

	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $A,     $A,     $A,    "source_sr/$treatment/$name-sr");
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $A,     $A,     $A,     $A,    "target_sr/$treatment/$name-sr");
# does not update og to match source because target contents not rewritten
	&makeit ($type, $A,     $A,     oct("007".$bb ),  $A,     $A,     $A,     $A,    "source_sr_right/$treatment/$name-sr");

$name = "$type-$treatment-t-change-og-differ";

#	                owner   group   mode              mtime   content symlink rdev
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $A,     $A,     $A,    "source/$treatment/$name");
	&makeit ($type, $bb,    $bb,    oct("007".$A  ),  $bb,    $A,     $A,     $A,    "target/$treatment/$name");
# updates og to match source because target remade for contents
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $A,     $A,     $A,    "target_right/$treatment/$name");

	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $A,     $A,     $A,    "source_sr/$treatment/$name-sr");
	&makeit ($type, $bb,    $bb,    oct("007".$A  ),  $bb,    $A,     $A,     $A,    "target_sr/$treatment/$name-sr");
# updates og to match source because target remade for contents
	&makeit ($type, $A,     $A,      oct("007".$A  ),  $bb,    $A,     $A,     $A,    "source_sr_right/$treatment/$name-sr");

}

&utime_bottom ($treatment);

#--

$treatment = 102;

&mkdir_top ($treatment);

if (1) {

foreach $type ("f", "d", "s", "p", "c", "b", "k") {

	$name = "$type-$treatment";

	$A   = "00";
	$bb  = "11";
	$CCC = "22";

#	                owner   group   mode              mtime   content symlink rdev
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $A,     $A,     $A,    "source/$treatment/$name");
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    $bb,    $bb,    $bb,   "target/$treatment/$name");
if (($type eq "f") || ($type eq "d") || ($type eq "k") || ($type eq "p")) {
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    $bb,    999,    999,   "target_right/$treatment/$name");
} else {
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     999,    $A,     $A,    "target_right/$treatment/$name");
}

	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $A,     $A,     $A,    "source_sr/$treatment/$name-sr");
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    $bb,    $bb,    $bb,   "target_sr/$treatment/$name-sr");
if ($type eq "f") {
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $A,     $bb,    $bb,   "source_sr_right/$treatment/$name-sr");
} elsif ($type eq "d") {
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $A,     $bb,    $bb,   "source_sr_right/$treatment/$name-sr");
} elsif ($type eq "s") {
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $A,     $bb,    $bb,   "source_sr_right/$treatment/$name-sr");
} elsif ($type eq "p") {
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $A,     $bb,    $bb,   "source_sr_right/$treatment/$name-sr");
} elsif (($type eq "c") || ($type eq "b")) {
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    $A,     $bb,    $bb,   "source_sr_right/$treatment/$name-sr");
} elsif ($type eq "k") {
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $A,     $bb,    $bb,   "source_sr_right/$treatment/$name-sr");
} else {
	die "wrong type $type";
}

	$name = "$type-$treatment-ogmt-differs-plus-c-for-f";

#	                owner   group   mode              mtime   content symlink rdev
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $A,     $A,     $A,    "source/$treatment/$name");
if ($type eq "f") {
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    $bb,    999,    999,   "target/$treatment/$name");
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    $bb,    999,    999,   "target_right/$treatment/$name");
} elsif ($type eq "d") {
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    999,    $A,     $A,    "target/$treatment/$name");
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    999,    $A,     $A,    "target_right/$treatment/$name");
} elsif ($type eq "s") {
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    999,    $A,     $A,    "target/$treatment/$name");
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    999,    $A,     $A,    "target_right/$treatment/$name");
} elsif ($type eq "p") {
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    999,    $A,     $A,    "target/$treatment/$name");
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    999,    $A,     $A,    "target_right/$treatment/$name");
} elsif (($type eq "c") || ($type eq "b")) {
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    999,    $A,     $A,    "target/$treatment/$name");
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    999,    $A,     $A,    "target_right/$treatment/$name");
} elsif ($type eq "k") {
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    999,    $A,     $A,    "target/$treatment/$name");
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    999,    $A,     $A,    "target_right/$treatment/$name");
} else {
	die "wrong type $type";
}

	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $A,     $A,     $A,    "source_sr/$treatment/$name-sr");
if ($type eq "f") {
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    $bb,    999,    999,   "target_sr/$treatment/$name-sr");
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $A,     999,    999,   "source_sr_right/$treatment/$name-sr");
} elsif ($type eq "d") {
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    999,    $A,     $A,    "target_sr/$treatment/$name-sr");
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     999,    $A,     $A,    "source_sr_right/$treatment/$name-sr");
} elsif ($type eq "s") {
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    999,    $A,     $A,    "target_sr/$treatment/$name-sr");
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     999,    $A,     $A,    "source_sr_right/$treatment/$name-sr");
} elsif ($type eq "p") {
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    999,    $A,     $A,    "target_sr/$treatment/$name-sr");
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     999,    $A,     $A,    "source_sr_right/$treatment/$name-sr");
} elsif (($type eq "c") || ($type eq "b")) {
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    999,    $A,     $A,    "target_sr/$treatment/$name-sr");
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     999,    $A,     $A,    "source_sr_right/$treatment/$name-sr");
} elsif ($type eq "k") {
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    999,    $A,     $A,    "target_sr/$treatment/$name-sr");
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     999,    $A,     $A,    "source_sr_right/$treatment/$name-sr");
} else {
	die "wrong type $type";
}

}

}

&utime_bottom ($treatment);

#--

$treatment = 103;

&mkdir_top ($treatment);
&mkdir_top_alt ($treatment);

if (1) {

foreach $type ("f", "d", "s", "p", "c", "b", "k") {

	$name = "$type-$treatment";

	$A   = "00";
	$bb  = "11";
	$CCC = "22";

# different contents file
#	                owner   group   mode              mtime   content symlink rdev
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $A,     $A,     $A,    "source/$treatment/$name");
	&makeit ($type, $CCC,   $CCC,   oct("007".$CCC),  $CCC,   $CCC,   $CCC,   $CCC,  "source_alt/$treatment/$name");
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    $bb,    $bb,    $bb,   "target/$treatment/$name");
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $CCC,   $CCC,   $CCC,  "target_right/$treatment/$name");

	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $A,     $A,     $A,    "source_sr/$treatment/$name-sr");
	&makeit ($type, $CCC,   $CCC,   oct("007".$CCC),  $CCC,   $CCC,   $CCC,   $CCC,  "source_alt_sr/$treatment/$name-sr");
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    $bb,    $bb,    $bb,   "target_sr/$treatment/$name-sr");
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    $A,     $A,     $A,    "source_sr_right/$treatment/$name-sr");
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    $bb,    $bb,    $bb,   "source_alt_sr_right/$treatment/$name-sr");

	$name = "$type-$treatment-same-contents";
# same contents file
#	                owner   group   mode              mtime   content symlink rdev
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $A,     $A,     $A,    "source/$treatment/$name");
	&makeit ($type, $CCC,   $CCC,   oct("007".$CCC),  $CCC,   $CCC,   $CCC,   $CCC,  "source_alt/$treatment/$name");
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    $CCC,   $CCC,   $CCC,  "target/$treatment/$name");
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $CCC,   $CCC,   $CCC,  "target_right/$treatment/$name");

	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $A,     $A,     $A,    "source_sr/$treatment/$name-sr");
	&makeit ($type, $CCC,   $CCC,   oct("007".$CCC),  $CCC,   $CCC,   $CCC,   $CCC,  "source_alt_sr/$treatment/$name-sr");
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    $CCC,   $CCC,   $CCC,  "target_sr/$treatment/$name-sr");
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    $A,     $A,     $A,    "source_sr_right/$treatment/$name-sr");
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    $CCC,   $CCC,   $CCC,  "source_alt_sr_right/$treatment/$name-sr");

	$name = "$type-$treatment-should-be-no-updates";
#	                owner   group   mode              mtime   content symlink rdev
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $A,     $A,     $A,    "source/$treatment/$name");
	&makeit ($type, $CCC,   $CCC,   oct("007".$CCC),  $CCC,   $CCC,   $CCC,   $CCC,  "source_alt/$treatment/$name");
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    $CCC,   $CCC,   $CCC,  "target/$treatment/$name");
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $CCC,   $CCC,   $CCC,  "target_right/$treatment/$name");

	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $A,     $A,     $A,    "source_sr/$treatment/$name-sr");
	&makeit ($type, $CCC,   $CCC,   oct("007".$CCC),  $CCC,   $CCC,   $CCC,   $CCC,  "source_alt_sr/$treatment/$name-sr");
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $CCC,   $CCC,   $CCC,  "target_sr/$treatment/$name-sr");
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $A,     $A,     $A,    "source_sr_right/$treatment/$name-sr");
	&makeit ($type, $CCC,   $CCC,   oct("007".$CCC),  $CCC,   $CCC,   $CCC,   $CCC,  "source_alt_sr_right/$treatment/$name-sr");
}

}

&utime_bottom ($treatment);
&utime_bottom_alt ($treatment);

#--

$treatment = 113;

&mkdir_top ($treatment);
&mkdir_top_alt ($treatment);

if (1) {

foreach $type ("f", "d", "s", "p", "c", "b", "k") {

	$name = "$type-$treatment";

	$A   = "00";
	$bb  = "11";
	$CCC = "22";

# different contents file
#	                owner   group   mode              mtime   content symlink rdev
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $A,     $A,     $A,    "source/$treatment/$name");
	&makeit ($type, $CCC,   $CCC,   oct("007".$CCC),  $CCC,   $CCC,   $CCC,   $CCC,  "source_alt/$treatment/$name");
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    $bb,    $bb,    $bb,   "target/$treatment/$name");
if ($type eq "d") {
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $bb,    $CCC,   $CCC,   $CCC,  "target_right/$treatment/$name");
# XXX ALTERED TO MATCH RESULTS                            v formerly $A
} elsif (($type eq "k") || ($type eq "p")) {
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $bb,    999,    999,    999,   "target_right/$treatment/$name");
} else {
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $CCC,   $CCC,   $CCC,  "target_right/$treatment/$name");
}

	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $A,     $A,     $A,    "source_sr/$treatment/$name-sr");
	&makeit ($type, $CCC,   $CCC,   oct("007".$CCC),  $CCC,   $CCC,   $CCC,   $CCC,  "source_alt_sr/$treatment/$name-sr");
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    $bb,    $bb,    $bb,   "target_sr/$treatment/$name-sr");
if ($type eq "f") {
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $A,     $A,     $A,     $A,    "source_sr_right/$treatment/$name-sr");
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    $bb,    $bb,    $bb,   "source_alt_sr_right/$treatment/$name-sr");
} elsif ($type eq "d") {
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $A,     $A,     $A,     $A,    "source_sr_right/$treatment/$name-sr");
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $CCC,   $bb,    $bb,    $bb,   "source_alt_sr_right/$treatment/$name-sr");
} elsif ($type eq "s") {
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    $A,     $A,     $A,    "source_sr_right/$treatment/$name-sr");
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    $bb,    $bb,    $bb,   "source_alt_sr_right/$treatment/$name-sr");
} elsif ($type eq "p") {
# XXX ALTERED TO MATCH RESULTS                            v formerly $bb
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $A,     $A,     $A,     $A,    "source_sr_right/$treatment/$name-sr");
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $CCC,   $bb,    $bb,    $bb,   "source_alt_sr_right/$treatment/$name-sr");
} elsif (($type eq "c") || ($type eq "b")) {
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $A,     $A,     $A,     $A,    "source_sr_right/$treatment/$name-sr");
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    $bb,    $bb,    $bb,   "source_alt_sr_right/$treatment/$name-sr");
} elsif ($type eq "k") {
# XXX ALTERED TO MATCH RESULTS                            v formerly $bb
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $A,     $A,     $A,     $A,    "source_sr_right/$treatment/$name-sr");
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $CCC,   $bb,    $bb,    $bb,   "source_alt_sr_right/$treatment/$name-sr");
} else {
	die "wrong type $type";
}

	$name = "$type-$treatment-same-contents";
# same contents file
#	                owner   group   mode              mtime   content symlink rdev
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $A,     $A,     $A,    "source/$treatment/$name");
	&makeit ($type, $CCC,   $CCC,   oct("007".$CCC),  $CCC,   $CCC,   $CCC,   $CCC,  "source_alt/$treatment/$name");
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    $CCC,   $CCC,   $CCC,  "target/$treatment/$name");
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $bb,    $CCC,   $CCC,   $CCC,  "target_right/$treatment/$name");

	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $A,     $A,     $A,    "source_sr/$treatment/$name-sr");
	&makeit ($type, $CCC,   $CCC,   oct("007".$CCC),  $CCC,   $CCC,   $CCC,   $CCC,  "source_alt_sr/$treatment/$name-sr");
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    $CCC,   $CCC,   $CCC,  "target_sr/$treatment/$name-sr");
if ($type eq "f") {
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $A,     $A,     $A,     $A,    "source_sr_right/$treatment/$name-sr");
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $CCC,   $CCC,   $CCC,   $CCC,  "source_alt_sr_right/$treatment/$name-sr");
} elsif ($type eq "d") {
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $A,     $A,     $A,     $A,    "source_sr_right/$treatment/$name-sr");
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $CCC,   $CCC,   $CCC,   $CCC,  "source_alt_sr_right/$treatment/$name-sr");
} elsif ($type eq "s") {
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $A,     $A,     $A,     $A,    "source_sr_right/$treatment/$name-sr");
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $CCC,   $CCC,   $CCC,   $CCC,  "source_alt_sr_right/$treatment/$name-sr");
} elsif ($type eq "p") {
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $A,     $A,     $A,     $A,    "source_sr_right/$treatment/$name-sr");
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $CCC,   $CCC,   $CCC,   $CCC,  "source_alt_sr_right/$treatment/$name-sr");
} elsif (($type eq "c") || ($type eq "b")) {
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $A,     $A,     $A,     $A,    "source_sr_right/$treatment/$name-sr");
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $CCC,   $CCC,   $CCC,   $CCC,  "source_alt_sr_right/$treatment/$name-sr");
} elsif ($type eq "k") {
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $A,     $A,     $A,     $A,    "source_sr_right/$treatment/$name-sr");
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $CCC,   $CCC,   $CCC,   $CCC,  "source_alt_sr_right/$treatment/$name-sr");
} else {
	die "wrong type $type";
}

	$name = "$type-$treatment-should-be-no-updates";
#	                owner   group   mode              mtime   content symlink rdev
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $A,     $A,     $A,    "source/$treatment/$name");
	&makeit ($type, $CCC,   $CCC,   oct("007".$CCC),  $CCC,   $CCC,   $CCC,   $CCC,  "source_alt/$treatment/$name");
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    $CCC,   $CCC,   $CCC,  "target/$treatment/$name");
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $bb,    $CCC,   $CCC,   $CCC,  "target_right/$treatment/$name");

	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $A,     $A,     $A,    "source_sr/$treatment/$name-sr");
	&makeit ($type, $CCC,   $CCC,   oct("007".$CCC),  $CCC,   $CCC,   $CCC,   $CCC,  "source_alt_sr/$treatment/$name-sr");
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $bb,    $CCC,   $CCC,   $CCC,  "target_sr/$treatment/$name-sr");
if ($type eq "f") {
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $A,     $A,     $A,    "source_sr_right/$treatment/$name-sr");
	&makeit ($type, $CCC,   $CCC,   oct("007".$CCC),  $CCC,   $CCC,   $CCC,   $CCC,  "source_alt_sr_right/$treatment/$name-sr");
} elsif ($type eq "d") {
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $A,     $A,     $A,    "source_sr_right/$treatment/$name-sr");
	&makeit ($type, $CCC,   $CCC,   oct("007".$CCC),  $CCC,   $CCC,   $CCC,   $CCC,  "source_alt_sr_right/$treatment/$name-sr");
} elsif ($type eq "s") {
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $A,     $A,     $A,    "source_sr_right/$treatment/$name-sr");
	&makeit ($type, $CCC,   $CCC,   oct("007".$CCC),  $CCC,   $CCC,   $CCC,   $CCC,  "source_alt_sr_right/$treatment/$name-sr");
} elsif ($type eq "p") {
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $A,     $A,     $A,    "source_sr_right/$treatment/$name-sr");
	&makeit ($type, $CCC,   $CCC,   oct("007".$CCC),  $CCC,   $CCC,   $CCC,   $CCC,  "source_alt_sr_right/$treatment/$name-sr");
} elsif (($type eq "c") || ($type eq "b")) {
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $A,     $A,     $A,    "source_sr_right/$treatment/$name-sr");
	&makeit ($type, $CCC,   $CCC,   oct("007".$CCC),  $CCC,   $CCC,   $CCC,   $CCC,  "source_alt_sr_right/$treatment/$name-sr");
} elsif ($type eq "k") {
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $A,     $A,     $A,    "source_sr_right/$treatment/$name-sr");
	&makeit ($type, $CCC,   $CCC,   oct("007".$CCC),  $CCC,   $CCC,   $CCC,   $CCC,  "source_alt_sr_right/$treatment/$name-sr");
} else {
	die "wrong type $type";
}

}

}

&utime_bottom ($treatment);
&utime_bottom_alt ($treatment);

#--

$treatment = 104;

if (1) {

&mkdir_top ($treatment);

foreach $type ("f", "d", "s", "p", "c", "b", "k") {

	$name = "$type-$treatment";

	$A   = "00";
	$bb  = "11";
	$CCC = "22";

#	                owner   group   mode              mtime   content symlink rdev
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $A,     $A,     $A,    "source/$treatment/$name");
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    $bb,    $bb,    $bb,   "target/$treatment/$name");
if (($type eq "f") || ($type eq "d")) {
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $bb,    $bb,    999,    999,   "target_right/$treatment/$name");
# XXX ALTERED TO MATCH RESULTS                            v formerly $A
} elsif (($type eq "k") || ($type eq "p")) {
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $bb,    999,    999,    999,   "target_right/$treatment/$name");
} else {
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     999,    $A,     $A,    "target_right/$treatment/$name");
}

	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $A,     $A,     $A,    "source_sr/$treatment/$name-sr");
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    $bb,    $bb,    $bb,   "target_sr/$treatment/$name-sr");
if ($type eq "f") {
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $A,     $A,     999,    999,   "source_sr_right/$treatment/$name-sr");
} elsif ($type eq "d") {
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $A,     999,    $bb,    $bb,   "source_sr_right/$treatment/$name-sr");
} elsif ($type eq "s") {
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    999,    $bb,    $bb,   "source_sr_right/$treatment/$name-sr");
} elsif ($type eq "p") {
# XXX ALTERED TO MATCH RESULTS                            v formerly $bb
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $A,     999,    $bb,    $bb,   "source_sr_right/$treatment/$name-sr");
} elsif (($type eq "c") || ($type eq "b")) {
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    999,    $bb,    $bb,   "source_sr_right/$treatment/$name-sr");
} elsif ($type eq "k") {
# XXX ALTERED TO MATCH RESULTS                            v formerly $bb
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $A,     999,    $bb,    $bb,   "source_sr_right/$treatment/$name-sr");
} else {
	die "wrong type $type";
}

}

}

&utime_bottom ($treatment);

#--

$treatment = 105;

if (1) {

&mkdir_top ($treatment);

foreach $type ("f", "d", "s", "p", "c", "b", "k") {

	$name = "$type-$treatment";

	$A   = "00";
	$bb  = "11";
	$CCC = "22";

#	                owner   group   mode              mtime   content symlink rdev
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $A,     $A,     $A,    "source/$treatment/$name");
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    $bb,    $bb,    $bb,   "target/$treatment/$name");
if (($type eq "f") || ($type eq "d")) {
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $bb,    $bb,    999,    999,   "target_right/$treatment/$name");
# XXX ALTERED TO MATCH RESULTS                            v formerly $A
} elsif (($type eq "k") || ($type eq "p")) {
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $bb,    999,    999,    999,   "target_right/$treatment/$name");
} else {
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     999,    $A,     $A,    "target_right/$treatment/$name");
}

	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $A,     $A,     $A,    "source_sr/$treatment/$name-sr");
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    $bb,    $bb,    $bb,   "target_sr/$treatment/$name-sr");

if ($type eq "f") {
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $A,     $A,     999,    999,   "source_sr_right/$treatment/$name-sr");
} elsif ($type eq "d") {
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $A,     999,    $bb,    $bb,   "source_sr_right/$treatment/$name-sr");
} elsif ($type eq "s") {
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    999,    $bb,    $bb,   "source_sr_right/$treatment/$name-sr");
} elsif ($type eq "p") {
# XXX ALTERED TO MATCH RESULTS                            v formerly $bb
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $A,     999,    $bb,    $bb,   "source_sr_right/$treatment/$name-sr");
} elsif (($type eq "c") || ($type eq "b")) {
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    999,    $bb,    $bb,   "source_sr_right/$treatment/$name-sr");
} elsif ($type eq "k") {
# XXX ALTERED TO MATCH RESULTS                            v formerly $bb
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $A,     999,    $bb,    $bb,   "source_sr_right/$treatment/$name-sr");
} else {
	die "wrong type $type";
}

	$name = "$type-$treatment-only-on-source";

#	                owner   group   mode              mtime   content symlink rdev
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $A,     $A,     $A,    "source/$treatment/$name");

	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $A,     $A,     $A,    "source_sr/$treatment/$name-sr");
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $A,     $A,     $A,    "source_sr_right/$treatment/$name-sr");
}

}

&utime_bottom ($treatment);

#--

$treatment = 106;

&mkdir_top ($treatment);
&mkdir_top_alt ($treatment);

if (1) {

foreach $type ("f", "d", "s", "p", "c", "b", "k") {

	$name = "$type-$treatment";

	$A   = "00";
	$bb  = "11";
	$CCC = "22";

#	                owner   group   mode              mtime   content symlink rdev
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $A,     $A,     $A,    "source/$treatment/$name");
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    $bb,    $bb,    $bb,   "target/$treatment/$name");
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $A,     $A,     $A,    "target_right/$treatment/$name");

	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $A,     $A,     $A,    "source_sr/$treatment/$name-sr");
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    $bb,    $bb,    $bb,   "target_sr/$treatment/$name-sr");
	&makeit ($type, $bb,    $bb,    oct("007".$bb ),  $bb,    $bb,    $bb,    $bb,   "source_sr_right/$treatment/$name-sr");
}

}

&utime_bottom ($treatment);
&utime_bottom_alt ($treatment);

#--

$treatment = 107;

if (1) {

&mkdir_top ($treatment);

foreach $type ("f", "d", "s", "p", "c", "b", "k") {

	$name = "$type";

	$A   = "00";
	$bb  = "11";
	$CCC = "22";

#	                owner   group   mode              mtime   content symlink rdev
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $A,     $A,     $A,    "source/$treatment/$name");
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $bb,    $A,     $A,     $A,    "target/$treatment/$name");
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $bb,    $A,     $A,     $A,    "target_right/$treatment/$name");

	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $A,     $A,     $A,    "source_sr/$treatment/$name-sr");
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $bb,    $A,     $A,     $A,    "target_sr/$treatment/$name-sr");
	&makeit ($type, $A,     $A,     oct("007".$A  ),  $A,     $A,     $A,     $A,    "source_sr_right/$treatment/$name-sr");

}

}

&utime_bottom ($treatment);

#--

$treatment = 207;

&mkdir_top ($treatment);

if (1) {

foreach $type ("f", "d", "s", "p", "c", "b", "k") {

	$name = "$type-$treatment";

	$A   = "00";
	$bb  = "11";
	$CCC = "22";

#	                owner   group   mode              mtime   content symlink rdev
	&makeit ($type, $CCC,   $CCC,   oct("007".$CCC),  $CCC,   $CCC,   $CCC,   $CCC,  "target/$treatment/$name");
	&makeit ($type, 33,     33,     oct("00733"   ),  $CCC,   $CCC,   $CCC,   $CCC,  "target_right/$treatment/$name");

	&makeit ($type, $CCC,   $CCC,   oct("007".$CCC),  $CCC,   $CCC,   $CCC,   $CCC,  "target_sr/$treatment/$name-sr");
	&makeit ($type, 33,     33,     oct("00733"   ),  $CCC,   $CCC,   $CCC,   $CCC,  "target_sr/$treatment/$name-right-ogm-sr");
}

}

&utime_bottom ($treatment);

#--

utime (1000000000, 1000000000, "source") || die "$!";
utime (1000000000, 1000000000, "target") || die "$!";
utime (1000000000, 1000000000, "target_right") || die "$!";

utime (1000000000, 1000000000, "source_sr") || die "$!";
utime (1000000000, 1000000000, "target_sr") || die "$!";
utime (1000000000, 1000000000, "source_sr_right") || die "$!";

utime (1000000000, 1000000000, "source_alt") || die "$!";

utime (1000000000, 1000000000, "source_alt_sr") || die "$!";
utime (1000000000, 1000000000, "source_alt_sr_right") || die "$!";

utime (1000000000, 1000000000, ".") || die "$!";

#--

exit (0);

#-----

sub makesocket {

	my $socketname = shift;

	unlink ($socketname);
	socket (theserver, &main::PF_UNIX, &main::SOCK_STREAM, 0) || die "$!";
	bind (theserver, &main::sockaddr_un ($socketname)) || die "$!";
}

sub chownifroot {

	my $owner = shift;
	my $group = shift;
	my $filename = shift;

	if ($> == 0) {
		chown ($owner, $group, $filename) || die "$!";
	}
}

sub utimeifroot {

	my $mtime = shift;
	my $name = shift;

	if ($> == 0) {
		utime ($mtime, $mtime, $name) || die "$!";
	}
}

sub chmodifroot {

	my $mode = shift;
	my $name = shift;

	if ($> == 0) {
		chmod ($mode, $name) || die "$!";
	}
}

sub mknodifroot {

	my $filename = shift;
	my $cb = shift;
	my $rdev = shift;

	if ($> == 0) {
		(!(system ('mknod', $filename, $cb, $rdev, '1') / 256)) || die "$!";
	}
}

sub touch {

	my $filename = shift;
	my $contents = shift;

	$filename =~ s#^(\s)#./$1#;
	open (TOUCH, '>', "$filename\0") || die "$!, filename $filename";
	if (defined ($contents)) {
		print TOUCH $contents;
	}
	close (TOUCH) || die "$!";
}

sub fakemakeit {

	warn join (', ', @_) . "\n";
}

sub makeit {

	my $type = shift;
	my $owner = shift;
	my $group = shift;
	my $mode = shift;
	my $mtime = shift;
	my $content = shift;
	my $symlinktarget = shift;
	my $rdev = shift;
	my $name = shift;

#	warn "sub makeit type $type name $name\n";

	if ($type eq "f") {
		&touch ($name, $content);
		&chownifroot ($owner, $group, $name);
		chmod ($mode, $name) || die "$!";
		utime ($mtime, $mtime, $name) || die "$!";
	} elsif ($type eq "d") {
		mkdir ($name, $mode) || die "name $name, error $!";
		&chownifroot ($owner, $group, $name);
		chmod ($mode, $name) || die "$!";
		utime ($mtime, $mtime, $name) || die "$!";
	} elsif ($type eq "s") {
		symlink ($symlinktarget, $name) || die "$!";
	} elsif ($type eq "p") {
		(!(system ('mkfifo', $name) / 256)) || die "$!";
		&chownifroot ($owner, $group, $name);
		chmod ($mode, $name) || die "$!";
		utime ($mtime, $mtime, $name) || die "$!";
	} elsif ($type eq "c") {
		&mknodifroot ($name, 'c', $rdev);
		&chownifroot ($owner, $group, $name);
		&chmodifroot ($mode, $name);
		&utimeifroot ($mtime, $name);
	} elsif ($type eq "b") {
		&mknodifroot ($name, 'b', $rdev);
		&chownifroot ($owner, $group, $name);
		&chmodifroot ($mode, $name);
		&utimeifroot ($mtime, $name);
	} elsif ($type eq "k") {
		&makesocket ($name);
		&chownifroot ($owner, $group, $name);
		chmod ($mode, $name) || die "$!";
		utime ($mtime, $mtime, $name) || die "$!";
	} else {
		die "unknown type $type";
	}
}
