
#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

#  Usage:
#
#	mkt_tree 1
#
#	[test mount merge walk]
#
#	mkt_tree 2

sub chownifroot {

	my $owner = shift;
	my $group = shift;
	my $filename = shift;

	if ($> == 0) {
		return (chown ($owner, $group, $filename));
	} else {
		return (1);
	}
}

sub touch {

	$filename = shift;
	$owner = shift;
	$group = shift;
	$contents = shift;

	$filename =~ s#^(\s)#./$1#;
	open (TOUCH, '>', "$filename\0") || die "$!";
	if (defined ($contents)) {
		print TOUCH $contents;
	}
	close (TOUCH) || die "$!";
	&chownifroot ($owner, $group, $filename) || die "$!";
	chmod (0644, $filename) || die "$!";
	utime (1000000000, 1000000000, $filename) || die "$!";
}

if ($ARGV[0] eq '1') {

	# make test directory under cd

	(!(system ('rm', '-rf', 't_tree') / 256)) || die "$!";
	mkdir ('t_tree', 0755) || die "$!";
	&chownifroot (0, 0, 't_tree') || die "$!";
	chdir ('t_tree') || die "$!";

	# use with two.hflayers or three.hflayers

	#  [0] = ['1', '2',        '3', '4',        '5', '6', '7', '8'];
	#  [1] = [          '2.5'                                     ];
	#  [2] = [     '2',        '3', '4'                           ];
	#  [3] = [                                  '5', '6'          ];
	#  [4] = [                           '4.5'                    ];
	#  [5] = ['1',                                             '8'];
	#  [6] = [     '2',                              '6'          ];
	#  [7] = ['1', '2', '2.5', '3', '4',        '5',      '7'     ];

	mkdir ('0', 0755) || die "$!";
	&chownifroot (0, 100, '0') || die "$!";

	&touch ('0/1', 0, 1);
	&touch ('0/2', 0, 2, 'b');
	&touch ('0/3', 0, 3, 'c');
	&touch ('0/4', 0, 4, 'd');
	&touch ('0/5', 0, 5, 'e');
	&touch ('0/6', 0, 6, 'f');
	&touch ('0/7', 0, 7, 'g');
	&touch ('0/8', 0, 8, 'h');

	mkdir ('1', 0755) || die "$!";
	&chownifroot (1, 101, '1') || die "$!";

	&touch ('1/2.5', 1, 9, 'i');

	mkdir ('2', 0755) || die "$!";
	&chownifroot (2, 102, '2') || die "$!";

	&touch ('2/2', 2, 10, 'j');
	&touch ('2/3', 2, 11, 'k');
	&touch ('2/4', 2, 12, 'l');

	mkdir ('3', 0755) || die "$!";
	&chownifroot (3, 103, '3') || die "$!";

	&touch ('3/5', 3, 13, 'm');
	&touch ('3/6', 3, 14, 'n');

	mkdir ('4', 0755) || die "$!";
	&chownifroot (4, 104, '4') || die "$!";

	&touch ('4/4.5', 4, 15, 'o');

	mkdir ('5', 0755) || die "$!";
	&chownifroot (5, 105, '5') || die "$!";

	&touch ('5/1', 5, 16, 'p');
	&touch ('5/8', 5, 17, 'q');

	mkdir ('6', 0755) || die "$!";
	&chownifroot (6, 106, '6') || die "$!";

	&touch ('6/2', 6, 18, 'r');
	&touch ('6/6', 6, 19, 's');

	mkdir ('7', 0755) || die "$!";
	&chownifroot (7, 107, '7') || die "$!";

	&touch ('7/1', 7, 20, 't');
	&touch ('7/2', 7, 21, 'u');
	&touch ('7/2.5', 7, 22, 'v');
	&touch ('7/3', 7, 23, 'w');
	&touch ('7/4', 7, 24, 'x');
	&touch ('7/5', 7, 25, 'y');
	&touch ('7/7', 7, 26, 'z');

	# directory mtimes

	utime (1000000000, 1000000000, '0') || die "$!";
	utime (1000000000, 1000000000, '1') || die "$!";
	utime (1000000000, 1000000000, '2') || die "$!";
	utime (1000000000, 1000000000, '3') || die "$!";
	utime (1000000000, 1000000000, '4') || die "$!";
	utime (1000000000, 1000000000, '5') || die "$!";
	utime (1000000000, 1000000000, '6') || die "$!";
	utime (1000000000, 1000000000, '7') || die "$!";

#	{ 'mount' => [ 't_tree/10', ''      ] },
#	{ 'mount' => [ 't_tree/11', '1'     ] },
#	{ 'mount' => [ 't_tree/12', '2'     ] },
#	{ 'mount' => [ 't_tree/13', '2/4'   ] },
#	{ 'mount' => [ 't_tree/14', '2/4/6' ] },
#	{ 'mount' => [ 't_tree/15', '3'     ] },
#	{ 'mount' => [ 't_tree/16', '7'     ] },
#	{ 'mount' => [ 't_tree/17', '7/6'   ] }

	mkdir ('10', 0755) || die "$!";
	&chownifroot (10, 1000, '10') || die "$!";

	&touch ('10/4', 10, 94, 'A');
	&touch ('10/5', 10, 95, 'B');
	&touch ('10/6', 10, 96, 'C');
	&touch ('10/8', 10, 98, 'D');

	mkdir ('10/1', 0755) || die "$!";
	&chownifroot (10, 1001, '10/1') || die "$!";
	utime (1000000000, 1000000000, '10/1') || die "$!";

	mkdir ('10/2', 0755) || die "$!";
	&chownifroot (10, 1002, '10/2') || die "$!";
	utime (1000000000, 1000000000, '10/2') || die "$!";

	mkdir ('10/3', 0755) || die "$!";
	&chownifroot (10, 1003, '10/3') || die "$!";
	utime (1000000000, 1000000000, '10/3') || die "$!";

	mkdir ('10/7', 0755) || die "$!";
	&chownifroot (10, 1004, '10/4') || die "$!";
	utime (1000000000, 1000000000, '10/7') || die "$!";

	mkdir ('11', 0755) || die "$!";
	&chownifroot (11, 1010, '11') || die "$!";

	&touch ('11/2.5', 1, 99, 'E');

	mkdir ('12', 0755) || die "$!";
	&chownifroot (12, 1020, '12') || die "$!";

	&touch ('12/2', 2, 910, 'F');
	&touch ('12/3', 2, 911, 'G');

	mkdir ('12/4', 0755) || die "$!";
	&chownifroot (12, 1011, '11') || die "$!";
	utime (1000000000, 1000000000, '12/4') || die "$!";

	mkdir ('13', 0755) || die "$!";
	&chownifroot (13, 1030, '13') || die "$!";

	&touch ('13/5', 3, 913, 'H');

	mkdir ('13/6', 0755) || die "$!";
	&chownifroot (13, 1013, '11') || die "$!";
	utime (1000000000, 1000000000, '13/6') || die "$!";

	mkdir ('14', 0755) || die "$!";
	&chownifroot (14, 1040, '14') || die "$!";

	&touch ('14/4.5', 4, 915, 'I');

	mkdir ('15', 0755) || die "$!";
	&chownifroot (15, 1050, '15') || die "$!";

	&touch ('15/1', 5, 916, 'J');
	&touch ('15/8', 5, 917, 'K');

	mkdir ('16', 0755) || die "$!";
	&chownifroot (16, 1060, '16') || die "$!";

	&touch ('16/2', 6, 918, 'L');

	mkdir ('16/6', 0755) || die "$!";
	&chownifroot (16, 1014, '11') || die "$!";
	utime (1000000000, 1000000000, '16/6') || die "$!";

	mkdir ('17', 0755) || die "$!";
	&chownifroot (17, 1070, '17') || die "$!";

	&touch ('17/1', 7, 920, 'M');
	&touch ('17/2', 7, 921, 'N');
	&touch ('17/2.5', 7, 922, 'O');
	&touch ('17/3', 7, 923, 'P');
	&touch ('17/4', 7, 924, 'Q');
	&touch ('17/5', 7, 925, 'R');
	&touch ('17/7', 7, 926, 'S');

	# directory mtimes

	utime (1000000000, 1000000000, '10') || die "$!";
	utime (1000000000, 1000000000, '11') || die "$!";
	utime (1000000000, 1000000000, '12') || die "$!";
	utime (1000000000, 1000000000, '13') || die "$!";
	utime (1000000000, 1000000000, '14') || die "$!";
	utime (1000000000, 1000000000, '15') || die "$!";
	utime (1000000000, 1000000000, '16') || die "$!";
	utime (1000000000, 1000000000, '17') || die "$!";

	# top level directory mtime

	utime (1000001000, 1000001000, '.') || die "$!";

} elsif ($ARGV[0] eq '2') {

	(!(system ('rm', '-rf', 't_tree') / 256)) || die "$!";

} else {

	die "Usage: $0 [1|2]\n";
}
