
#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

use lib '/@@@ USE LIB @@@';
use HF::Encode;

# make HF::Report->report work
$HF::Globals::islocal = 1;
$HF::Globals::verbosity = 20;

$ugly = '';
for ($i = 0;  $i < 255;  $i++) {
	$ugly .= chr ($i) . "\n";
}

&try ($ugly);

open (BINARY, '<', 'vmlinux-2.2.16-3') || die "$!";
{
	local ($/);
	$ugly = <BINARY>;
}
close (BINARY) || die "$!";

&try ($ugly);

sub try {

	my $ugly = shift;

	print "encoding...\n";

	$pretty = HF::Encode->encode ($ugly);

	#if ($pretty !~ /^[!-~]+$/) {
	if ($pretty =~ /^[^\041\050-\077\101-\133\135-\137\141-\176]+$/) {	# expanded to pass perl eval
		print "failed 1\n";
		exit (1);
	}

	print "decoding...\n";

	$reconstituted = HF::Encode->decode ($pretty);

	if ($reconstituted ne $ugly) {
		print "failed 2\n";
		exit (1);
	}

	$reconstituted = eval ('"' . $pretty . '";');

	if ($reconstituted ne $ugly) {
		print "failed 3\n";
		exit (1);
	}
}

print "passed\n";
exit (0);
