
#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

use lib '/@@@ USE LIB @@@';
use HF::HF;

if ($ARGV[0] ne '') {
	$startdir = $ARGV[0];
} else {
	$startdir = 't_names';
}

if (!(-d $startdir)) {
	die "startdir $startdir does not exist";
}

# make HF::Report->report work
$HF::Globals::islocal = 1;
$HF::Globals::verbosity = 20;

warn "startdir $startdir";

print "-------------------------------------------------------------------------------
walk a dir\n\n";

$walk = HF::FTWstream->new ($startdir, 'thisfilegrows|^sgiddir/', 1);

while ($walkres = $walk->next, defined ($walkres->{'dev'})) {

	print "enc(path) " . HF::Encode->encode ($walkres->{'path'}) . "\n";
#	print "encpath " . $walkres->{'encpath'} . "\n";

#	print "enc(startdir) " . HF::Encode->encode ($walkres->{'startdir'}) . "\n";
#	print "encstartdir " . $walkres->{'encstartdir'} . "\n";

	print "enc(name) " . HF::Encode->encode ($walkres->{'name'}) ."\n";
#	print "encname " . $walkres->{'encname'} . "\n";

#	print "dev " . $walkres->{'dev'} . "\n";
	print "inode " . $walkres->{'inode'} . "\n";
#	printf ("mode %06o\n", $walkres->{'mode'});
#	print "links " . $walkres->{'links'} . "\n";
#	print "owner " . $walkres->{'owner'} . "\n";
#	print "group " . $walkres->{'group'} . "\n";
#	print "rdev " . $walkres->{'rdev'} . "\n";
#	print "size " . $walkres->{'size'} . "\n";
#	print "atime " . $walkres->{'atime'} . "\n";
#	print "mtime " . $walkres->{'mtime'} . "\n";
#	print "ctime " . $walkres->{'ctime'} . "\n";
#	print "blksize " . $walkres->{'blksize'} . "\n";
#	print "blocks " . $walkres->{'blocks'} . "\n";

#	print "type " . sprintf ("0%o", $walkres->{'type'}) . "\n";
#	print "perms " . sprintf ("0%o", $walkres->{'perms'}) . "\n";

#	print "enc(target) " . HF::Encode->encode ($walkres->{'target'}) . "\n";
#	print "enctarget " . $walkres->{'enctarget'} . "\n";

#	print "checksum " . $walkres->{'checksum'} . "\n";

	print "-----\n";
}

print "final startdir after undef: '" . $walkres->{'startdir'} . "'\n";

#-----

print "

-------------------------------------------------------------------------------
walk a file\n\n";

$walk = HF::FTWstream->new ('t_names/file', undef, 0);

while ($walkres = $walk->next, defined ($walkres->{'dev'})) {

	print "enc(path) " . HF::Encode->encode ($walkres->{'path'}) . "\n";
	print "encpath " . $walkres->{'encpath'} . "\n";

	print "enc(startdir) " . HF::Encode->encode ($walkres->{'startdir'}) . "\n";
	print "encstartdir " . $walkres->{'encstartdir'} . "\n";

	print "enc(name) " . HF::Encode->encode ($walkres->{'name'}) ."\n";
	print "encname " . $walkres->{'encname'} . "\n";

	print "dev " . $walkres->{'dev'} . "\n";
	print "inode " . $walkres->{'inode'} . "\n";
	printf ("mode %06o\n", $walkres->{'mode'});
	print "links " . $walkres->{'links'} . "\n";
	print "owner " . $walkres->{'owner'} . "\n";
	print "group " . $walkres->{'group'} . "\n";
	print "rdev " . $walkres->{'rdev'} . "\n";
	print "size " . $walkres->{'size'} . "\n";
	print "atime " . $walkres->{'atime'} . "\n";
	print "mtime " . $walkres->{'mtime'} . "\n";
	print "ctime " . $walkres->{'ctime'} . "\n";
	print "blksize " . $walkres->{'blksize'} . "\n";
	print "blocks " . $walkres->{'blocks'} . "\n";

	print "type " . sprintf ("0%o", $walkres->{'type'}) . "\n";
	print "perms " . sprintf ("0%o", $walkres->{'perms'}) . "\n";

	print "enc(target) " . HF::Encode->encode ($walkres->{'target'}) . "\n";
	print "enctarget " . $walkres->{'enctarget'} . "\n";

	print "checksum " . $walkres->{'checksum'} . "\n";

	print "-----\n";
}

print "final startdir after undef: '" . $walkres->{'startdir'} . "'\n";

#-----

print "

-------------------------------------------------------------------------------
walk a nonexistant dir\n\n";

$walk = HF::FTWstream->new ('t_names/thisdirnamedoesnotexist', undef, 0);

while ($walkres = $walk->next, defined ($walkres->{'dev'})) {

	print "enc(path) " . HF::Encode->encode ($walkres->{'path'}) . "\n";
	print "encpath " . $walkres->{'encpath'} . "\n";

	print "enc(startdir) " . HF::Encode->encode ($walkres->{'startdir'}) . "\n";
	print "encstartdir " . $walkres->{'encstartdir'} . "\n";

	print "enc(name) " . HF::Encode->encode ($walkres->{'name'}) ."\n";
	print "encname " . $walkres->{'encname'} . "\n";

	print "dev " . $walkres->{'dev'} . "\n";
	print "inode " . $walkres->{'inode'} . "\n";
	printf ("mode %06o\n", $walkres->{'mode'});
	print "links " . $walkres->{'links'} . "\n";
	print "owner " . $walkres->{'owner'} . "\n";
	print "group " . $walkres->{'group'} . "\n";
	print "rdev " . $walkres->{'rdev'} . "\n";
	print "size " . $walkres->{'size'} . "\n";
	print "atime " . $walkres->{'atime'} . "\n";
	print "mtime " . $walkres->{'mtime'} . "\n";
	print "ctime " . $walkres->{'ctime'} . "\n";
	print "blksize " . $walkres->{'blksize'} . "\n";
	print "blocks " . $walkres->{'blocks'} . "\n";

	print "type " . sprintf ("0%o", $walkres->{'type'}) . "\n";
	print "perms " . sprintf ("0%o", $walkres->{'perms'}) . "\n";

	print "enc(target) " . HF::Encode->encode ($walkres->{'target'}) . "\n";
	print "enctarget " . $walkres->{'enctarget'} . "\n";

	print "checksum " . $walkres->{'checksum'} . "\n";

	print "-----\n";
}

print "final startdir after undef: '" . $walkres->{'startdir'} . "'\n";
