
#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

use strict;

use lib '/@@@ USE LIB @@@';
use HF::HF;

$HF::Globals::verbosity = 20;

# -----

&HF::Hosts::eval_file_to_tmp ('three.hfhosts');
&HF::Hosts::parse_tmp_to_globals;
&HF::Hosts::display;

&HF::Layers::eval_file_to_tmp ('three.hflayers');
&HF::Layers::parse_tmp_to_globals;
&HF::Layers::display;

my $layersptr;
my $walkres;
my $firstsource = 1;
my $firsttarget = 1;

# -----

$layersptr = HF::Layers->new;
$layersptr->display;

# -----

$HF::Globals::islocal = 1;
$layersptr->source_sanitycheck;
$layersptr->source_start;

print "== source\n";

while ($walkres = $layersptr->source_next, defined ($walkres->{'name'})) {

	if ($firstsource == 1) {
		print "source keys: " . join (" ", sort (keys (%{$walkres}))) . "\n";
		$firstsource = 0;
	}

	printf ("%06o  %5d  %5d  %s\n",
		$walkres->{'type'},
		$walkres->{'owner'},
		$walkres->{'group'},
		$walkres->{'encname'});
}

# -----

$HF::Globals::islocal = 0;
$layersptr->target_sanitycheck;
$layersptr->target_start;

print "== target\n";

while ($walkres = $layersptr->target_next, defined ($walkres->{'name'})) {

	if ($firsttarget == 1) {
		print "target keys: " . join (" ", sort (keys (%{$walkres}))) . "\n";
		$firsttarget = 0;
	}

	printf ("%06o  %5d  %5d  %s\n",
		$walkres->{'type'},
		$walkres->{'owner'},
		$walkres->{'group'},
		$walkres->{'encname'});
}
