
#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

#  Usage:
#
#       test-marshal

use lib '/@@@ USE LIB @@@';
use HF::Marshal;

# make HF::Report->report work
$HF::Globals::islocal = 1;
$HF::Globals::verbosity = 20;

open (BINARY, '<', 'vmlinux-2.2.16-3') || die "$!";
{
	local ($/);
	$ugly = <BINARY>;
}
close (BINARY) || die "$!";

print "encoding...\n";

$pretty = HF::Marshal::marshal ($ugly);

open (SEEKABLE, '> test-marshal.tmp') || die "$!";

print SEEKABLE $pretty;

close (SEEKABLE) || die "$!";

print "decoding...\n";

open (SEEKABLE, '< test-marshal.tmp') || die "$!";

$reconstituted = HF::Marshal::unmarshal (\*SEEKABLE);

close (SEEKABLE) || die "$!";

unlink ('test-marshal.tmp') || die "$!";

if ($reconstituted ne $ugly) {
	print "failed\n";
	exit (1);
}

print "passed\n";
exit (0);

