#!/bin/bash -euET

#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

#
#  Usage:
#
#	test-propagation-complex.sh
#

CLEANEXIT=0
trap '
SAVEDSTATUS=$?
set +x
if [ "${CLEANEXIT:-0}" -ne 1 ]
then
	echo "${0##*/}: FATAL Unexpected return value of ${SAVEDSTATUS:-?}, line number ${ERR_LINENO:-?}, quitting" 1>&2
	exit $SAVEDSTATUS
fi' EXIT

trap 'ERR_LINENO=$LINENO' ERR

set -o pipefail

trap ': ${0##*/} line number $LINENO' DEBUG

#-----

set -x
set -o functrace

rm -rf t_random_tree t_random_tree2

mkdir -p t_random_tree/layers2-aaa/foo
#touch t_random_tree/layers2-ccc
touch -r test-propagation-complex.sh t_random_tree/layers2-aaa/foo t_random_tree/layers2-aaa
#touch -r test-propagation-complex.sh t_random_tree/layers2-ccc
ln -s layers2-aaa t_random_tree/layers2-bbb

mkdir -p t_random_tree2/layers2-bbb/foo
#touch t_random_tree2/layers2-ccc
touch -r test-propagation-complex.sh t_random_tree2/layers2-bbb/foo t_random_tree2/layers2-bbb
#touch -r test-propagation-complex.sh t_random_tree2/layers2-ccc

touch -r test-propagation-complex.sh t_random_tree t_random_tree2

../hf/sl t_random_tree > t_random_tree.sl

find t_random_tree -ls  | sort -k 11
find t_random_tree2 -ls | sort -k 11

../hf/hfdist -v 20 -wd t_random_tree t_random_tree2

../hf/sl t_random_tree2 > t_random_tree2.sl

diff t_random_tree.sl t_random_tree2.sl

rm -rf t_random_tree t_random_tree2 t_random_tree.sl t_random_tree2.sl

#-----

CLEANEXIT=1
exit 0
