#  Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2002, 2003, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020 Brian Bartholomew

tex_KNITS := \
	tex/elevator.knit

tex_TEXES := \
	tex/font-for-paper.tex \
	tex/font-for-web.tex \
	tex/geometry.tex \
	tex/installtour_src.tex \
	tex/layers-table.tex \
	tex/user_fake.tex \
	tex/user.tex

tex_OTHERS := \
	tex/module.mk \
	tex/GNUmakefile \
	tex/example-askpass.sh \
	tex/example.hfhosts \
	tex/example.hflayers \
	tex/hfdist-layers-example.hflayers \
	tex/hfdist-to-stdout.sh \
	tex/perl-in-a-file.hfhosts \
	tex/perl-in-a-file.hflayers

tex_RUNOUTPUT_TEX := \
	tex/runoutput/coprocess.tex \
	tex/runoutput/diffdb.tex \
	tex/runoutput/dropdb.tex \
	tex/runoutput/forkdb.tex \
	tex/runoutput/hf-bootstrap-pull-hfdist.tex \
	tex/runoutput/hf-bootstrap-pull-tar.tex \
	tex/runoutput/hf-bootstrap-push-bash.tex \
	tex/runoutput/hf-bootstrap-push-hfdist-test.tex \
	tex/runoutput/hf-bootstrap-push-hfdist.tex \
	tex/runoutput/hf-bootstrap-push-rdist.tex \
	tex/runoutput/hf-bootstrap-push-rsync.tex \
	tex/runoutput/hf-bootstrap-push-scp.tex \
	tex/runoutput/hf-bootstrap-push-tar.tex \
	tex/runoutput/hfcheck.tex \
	tex/runoutput/hf-decode.tex \
	tex/runoutput/hfdist.tex \
	tex/runoutput/hf-encode.tex \
	tex/runoutput/hf-flag--version.tex \
	tex/runoutput/hfgen.tex \
	tex/runoutput/hflayers.tex \
	tex/runoutput/hflog.tex \
	tex/runoutput/hf-reloaddb.tex \
	tex/runoutput/hf-root.tex \
	tex/runoutput/hf.tex \
	tex/runoutput/hf-version.tex \
	tex/runoutput/hf-winnow-versions.tex \
	tex/runoutput/lsdb.tex \
	tex/runoutput/map-table.svg \
	tex/runoutput/oelbig.tex \
	tex/runoutput/oelfork.tex \
	tex/runoutput/oelserver.tex \
	tex/runoutput/oel.tex \
	tex/runoutput/oe.tex \
	tex/runoutput/oewatch.tex \
	tex/runoutput/oh-doc.sh \
	tex/runoutput/oh.tex \
	tex/runoutput/omar.tex \
	tex/runoutput/sl-sum.tex \
	tex/runoutput/sl.tex

tex_RUNOUTPUT_PDF := \
	tex/runoutput/byroom.pdf \
	tex/runoutput/byusername.pdf \
	tex/runoutput/map-floorplan.pdf \
	tex/runoutput/map-table.pdf

tex_SOURCES := \
	$(tex_KNITS) \
	$(tex_TEXES) \
	$(tex_OTHERS) \
	$(tex_RUNOUTPUT_TEX) \
	$(tex_RUNOUTPUT_PDF)

tex_BASH_TESTME := \
	tex/example-askpass.sh \
	tex/hfdist-to-stdout.sh

tex_PERL_TESTME := \
	tex/example.hfhosts \
	tex/example.hflayers \
	tex/hfdist-layers-example.hflayers \
	tex/perl-in-a-file.hfhosts \
	tex/perl-in-a-file.hflayers

tex_BASH_RESULTS :=

tex_PERL_RESULTS :=

tex_RESULTS := \
	$(tex_BASH_RESULTS) \
	$(tex_PERL_RESULTS) \
	tex/ddl-short.tex \
	tex/elevator.html \
	tex/elevator.sh \
	tex/elevator.tex \
	tex/example-askpass_sh.tex \
	tex/example_hfhosts.tex \
	tex/example_hflayers.tex \
	tex/hfdist-layers-example-trunc.hflayers \
	tex/hfdist-layers-example-trunc_hflayers.tex \
	tex/hfdist-to-stdout_sh.tex \
	tex/hgrevid.tex \
	tex/installtour.tex \
	tex/manpages.tex \
	tex/paths.tex \
	tex/perl-in-a-file_hfhosts.tex \
	tex/perl-in-a-file_hflayers.tex \
	tex/schema.pdf \
	tex/schema.ps \
	tex/tables.tex \
	tex/tree.tex \
	tex/user.pdf \
	tex/versions.tex \
	$(patsubst %.pdf,%.ps,$(tex_RUNOUTPUT_PDF))

# Dependencies deliberately hidden.  make install will install
# repeatedly using old md5 values.  make clean will update md5 values.
tex/md5:
	cat $(tex_SOURCES) | md5sum | awk '{print $$1}' > tex/md5

tex/user.pdf: tex/user.tex \
	dot/arch.pdf \
	dot/mailflow.pdf \
	svg/dataflow-all.pdf \
	svg/dataflow-collect.pdf \
	svg/dataflow-dist.pdf \
	svg/layers-103-inv.pdf \
	svg/layers-103.pdf \
	svg/layers-stack.pdf \
	svg/layers-terms.pdf \
	svg/leadership-triangle.pdf \
	svg/product-venn.pdf \
	svg/swiss-army-knife.jpg \
	svg/wv-sm.pdf \
	tbl/hosts.tex \
	tbl/TYPES.tex \
	tex/ddl-short.tex \
	tex/dml.tex \
	tex/elevator.tex \
	tex/example-askpass_sh.tex \
	tex/example_hfhosts.tex \
	tex/example_hflayers.tex \
	tex/font-for-paper.tex \
	tex/geometry.tex \
	tex/hfdist-layers-example-trunc_hflayers.tex \
	tex/hfdist-to-stdout_sh.tex \
	tex/hgrevid.tex \
	tex/installtour.tex \
	tex/layers-table.tex \
	tex/manpages.tex \
	tex/paths.tex \
	tex/perl-in-a-file_hfhosts.tex \
	tex/perl-in-a-file_hflayers.tex \
	tex/runoutput/byroom.pdf \
	tex/runoutput/byusername.pdf \
	tex/runoutput/coprocess.tex \
	tex/runoutput/diffdb.tex \
	tex/runoutput/dropdb.tex \
	tex/runoutput/forkdb.tex \
	tex/runoutput/hf-bootstrap-pull-hfdist.tex \
	tex/runoutput/hf-bootstrap-pull-tar.tex \
	tex/runoutput/hf-bootstrap-push-bash.tex \
	tex/runoutput/hf-bootstrap-push-hfdist-test.tex \
	tex/runoutput/hf-bootstrap-push-hfdist.tex \
	tex/runoutput/hf-bootstrap-push-rdist.tex \
	tex/runoutput/hf-bootstrap-push-rsync.tex \
	tex/runoutput/hf-bootstrap-push-scp.tex \
	tex/runoutput/hf-bootstrap-push-tar.tex \
	tex/runoutput/hfcheck.tex \
	tex/runoutput/hfdist.tex \
	tex/runoutput/hf-flag--version.tex \
	tex/runoutput/hfgen.tex \
	tex/runoutput/hflayers.tex \
	tex/runoutput/hflog.tex \
	tex/runoutput/hf-reloaddb.tex \
	tex/runoutput/hf-root.tex \
	tex/runoutput/hf.tex \
	tex/runoutput/hf-version.tex \
	tex/runoutput/hf-winnow-versions.tex \
	tex/runoutput/lsdb.tex \
	tex/runoutput/map-floorplan.pdf \
	tex/runoutput/map-table.pdf \
	tex/runoutput/oelbig.tex \
	tex/runoutput/oelfork.tex \
	tex/runoutput/oelserver.tex \
	tex/runoutput/oel.tex \
	tex/runoutput/oe.tex \
	tex/runoutput/oewatch.tex \
	tex/runoutput/oh.tex \
	tex/runoutput/omar.tex \
	tex/runoutput/sl-sum.tex \
	tex/runoutput/sl.tex \
	tex/schema.pdf \
	tex/tables.tex \
	tex/tree.tex \
	tex/versions.tex \
	treat/0-inverse.tex \
	treat/0-normal.tex \
	treat/101-inverse.tex \
	treat/101-normal.tex \
	treat/102-inverse.tex \
	treat/102-normal.tex \
	treat/103-inverse.tex \
	treat/103-normal.tex \
	treat/104-inverse.tex \
	treat/104-normal.tex \
	treat/105-inverse.tex \
	treat/105-normal.tex \
	treat/106-inverse.tex \
	treat/106-normal.tex \
	treat/109-inverse.tex \
	treat/109-normal.tex \
	treat/113-inverse.tex \
	treat/113-normal.tex
	cd tex && pdflatex user.tex && pdflatex user.tex && pdflatex user.tex

tex/versions.tex: md5 $(COMPONENTMD5S) bin/versionsintex
	bin/versionsintex md5 $(COMPONENTMD5S) > tex/versions.tex

tex/paths.tex: bin/pathsintex
	bin/pathsintex > tex/paths.tex

tex/hgrevid.tex: bin/hgrevid
	echo Mercurial commit time: `bin/hgrevid -d` ' \newline' > tex/hgrevid.tex || :
	echo Mercurial changeset id: `bin/hgrevid` >> tex/hgrevid.tex || :

db/HF/Schema.pm: sql/ddl.sql
tex/ddl.tex: sql/ddl.sql
tex/dml.tex: sql/dml.sql
tex/schema.dot: sql/ddl.sql
tex/tables.tex: sql/ddl.sql

tex/ddl-short.tex: tex/ddl.tex
	awk '/^\\subsubsection\{hosts table\}$$/, /^\\end\{quote\}$$/ { print }' < tex/ddl.tex > tex/ddl-short.tex

tex/elevator.tex tex/elevator.html tex/elevator.sh: bin/knit tex/elevator.knit svg/factory.pdf svg/factory.svg
	(cd tex && ../bin/knit elevator.knit)

tex/installtour.tex: tex/installtour_src.tex
	sed -e "s|@@@ USE LIB @@@|$(HFPERLLIB)|g" \
		-e "s|@@@ HFPREFIX @@@|$(HFPREFIX)|g" \
		-e "s|@@@ HFMAJTOP @@@|$(HFMAJTOP)|g" \
		-e "s|@@@ HFTOP @@@|$(HFTOP)|g" \
		-e "s|@@@ HFSITETOP @@@|$(HFSITETOP)|g" \
		-e "s|@@@ HFBULKTOP @@@|$(HFBULKTOP)|g" \
		< tex/installtour_src.tex > tex/installtour.tex

tex/tree.tex: bin/treeintex
	tree -d --charset ascii --noreport -I 'install|dist|*_*|hfexample1' | bin/treeintex > tex/tree.tex

tex/manpages.tex: bin/mk-pod-latex $(ALLEXTPODS)
	bin/mk-pod-latex $(ALLEXTPODS) | \
	sed -e "s|@@@ EXAMPLEDB @@@|$(EXAMPLEDB)|g" \
		-e "s|@@@ GENPIECES @@@|$(gen_PIECES)|g" \
		-e "s|@@@ HFBULKTOP @@@|$(HFBULKTOP)|g" \
		-e "s|@@@ HFMAJLINK @@@|$(HFMAJLINK)|g" \
		-e "s|@@@ HFMAJTOP @@@|$(HFMAJTOP)|g" \
		-e "s|@@@ HFMAJVER @@@|$(HFMAJVER)|g" \
		-e "s|@@@ HFPREFIX @@@|$(HFPREFIX)|g" \
		-e "s|@@@ HFSITETOP @@@|$(HFSITETOP)|g" \
		-e "s|@@@ HFTOP @@@|$(HFTOP)|g" \
		-e "s|@@@ HFVER @@@|$(HFVER)|g" \
		-e "s|@@@ HG VERSION @@@|`cat hf/hgrevid.out`|g" \
		-e "s|@@@ PORTALLOCATE TOP @@@|$(PORTALLOCATETOP)|g" \
		-e "s|@@@ USE LIB @@@|$(HFPERLLIB)|g" > tex/manpages.tex

tex/example-askpass_sh.tex: bin/verbatimintex tex/example-askpass.sh
	bin/verbatimintex footnotesize tex/example-askpass.sh

tex/example_hfhosts.tex: bin/verbatimintex tex/example.hfhosts
	bin/verbatimintex footnotesize tex/example.hfhosts

tex/example_hflayers.tex: bin/verbatimintex tex/example.hflayers
	bin/verbatimintex footnotesize tex/example.hflayers

tex/hfdist-layers-example-trunc.hflayers: tex/hfdist-layers-example.hflayers
	awk '{if ($$0 ~ /CUT.HERE/) { exit } else { print }}' \
		< tex/hfdist-layers-example.hflayers \
		> tex/hfdist-layers-example-trunc.hflayers

tex/hfdist-layers-example-trunc_hflayers.tex: bin/verbatimintex tex/hfdist-layers-example-trunc.hflayers
	bin/verbatimintex tiny tex/hfdist-layers-example-trunc.hflayers

tex/hfdist-to-stdout_sh.tex: bin/verbatimintex tex/hfdist-to-stdout.sh
	bin/verbatimintex footnotesize tex/hfdist-to-stdout.sh

tex/perl-in-a-file_hfhosts.tex: bin/verbatimintex tex/perl-in-a-file.hfhosts
	bin/verbatimintex footnotesize tex/perl-in-a-file.hfhosts

tex/perl-in-a-file_hflayers.tex: bin/verbatimintex tex/perl-in-a-file.hflayers
	bin/verbatimintex footnotesize tex/perl-in-a-file.hflayers

.PHONY: build_tex
build_tex: $(tex_RESULTS) tex/md5 ## Build tex

.PHONY: clean_tex
clean_tex: ## Clean tex
	rm -f $(strip $(tex_RESULTS) tex/user.log tex/user.toc tex/user.aux tex/user.out tex/schema.ps tex/schema.pdf tex/md5)

.PHONY: install_tex
install_tex: installstep1 $(tex_RESULTS) tex/md5 ## Install tex
	cp -a tex/user.pdf install/$(HFTOP)/doc/user.pdf
