#
#    init -- creates an empty Hg repository and omar
#            support to allow version control of a Linux root partition filetree
#
#	$ oh init
#	STATUS doing init
#	adding omar-1.5
#	STATUS init done
#	STATUS next step is to write files to the 'oh' dir
#	STATUS total elapsed time 1 seconds aka 0 minutes
#
#    wrap -- massage the filetree so that it is ready for an Hg commit
#
#	$ touch oh/foo oh/bar
#	$ mkdir oh/baz
#	$ oh wrap
#	STATUS doing wrap
#	STATUS doing omar create
#	0.03 user 0.01 system 0:00.05 elapsed
#	STATUS doing hg addremove
#	adding oh-2.0/bar
#	adding oh-2.0/foo
#	Time: real 0.030 secs (user 0.000+0.000 sys 0.000+0.000)
#	STATUS wrap done
#	STATUS next step is to oh commit
#	STATUS total elapsed time 0 seconds aka 0 minutes
#
#    status -- what state is the repository in?
#
#	$ oh status
#	STATUS doing status
#	STATUS looks wrapped
#	STATUS doing hg status
#	Time: real 0.010 secs (user 0.000+0.000 sys 0.010+0.000)
#	M omar-1.5
#	A oh-2.0/bar
#	A oh-2.0/foo
#	STATUS 3 hg status lines
#	STATUS 4 omar lines
#	STATUS status done
#	STATUS if hg status lines are sensible, next step is to oh commit
#	STATUS total elapsed time 0 seconds aka 0 minutes
#
#    commit -- do the Hg commit
#
#	$ oh commit 'Initial checkin'
#	STATUS doing commit
#	STATUS doing hg commit
#	Time: real 0.010 secs (user 0.010+0.000 sys 0.000+0.000)
#	STATUS commit done
#	STATUS next step is to oh unwrap
#	STATUS total elapsed time 0 seconds aka 0 minutes
#
#    unwrap -- massage the filetree so that it is ready to have files written
#
#	$ oh unwrap
#	STATUS doing unwrap
#	STATUS doing hg update
#	resolving manifests
#	0 files updated, 0 files merged, 0 files removed, 0 files unresolved
#	Time: real 0.030 secs (user 0.000+0.000 sys 0.010+0.000)
#	STATUS doing omar extract
#	0.03 user 0.00 system 0:00.04 elapsed
#	STATUS unwrap done
#	STATUS next step is to write files to the 'oh' dir
#	STATUS total elapsed time 1 seconds aka 0 minutes
#
#    fix -- make working set files consistent with present hg revision
#
#	$ rm -r oh/baz   # oops!
#	$ oh fix -y
#	STATUS doing fix
#	rm -rf ./oh/foo ./oh/bar ./omar-1.5 
#	resolving manifests
#	getting oh-2.0/bar
#	getting oh-2.0/foo
#	getting omar-1.5
#	3 files updated, 0 files merged, 0 files removed, 0 files unresolved
#	Time: real 0.010 secs (user 0.010+0.000 sys 0.000+0.000)
#	STATUS doing status
#	STATUS looks wrapped
#	STATUS doing hg status
#	Time: real 0.010 secs (user 0.010+0.000 sys 0.000+0.000)
#	STATUS 0 hg status lines
#	STATUS 4 omar lines
#	STATUS status done
#	STATUS next step is to oh unwrap
#	STATUS total elapsed time 0 seconds aka 0 minutes
#	STATUS fix done, hg local revision number is 1
#	STATUS next step is to oh unwrap
#
#    snapshot -- wrap, commit, unwrap
#
#	$ oh unwrap
#	[ ...output deleted... ]
#	$ touch oh/a1 oh/b1 oh/c1
#	$ oh snapshot 'More mods'
#	STATUS doing snapshot
#	STATUS doing wrap
#	STATUS doing omar create
#	0.04 user 0.00 system 0:00.05 elapsed
#	STATUS doing hg addremove
#	adding oh-2.0/a1
#	adding oh-2.0/b1
#	adding oh-2.0/c1
#	Time: real 0.010 secs (user 0.010+0.000 sys 0.000+0.000)
#	STATUS wrap done
#	STATUS next step is to oh commit
#	STATUS total elapsed time 1 seconds aka 0 minutes
#	STATUS doing commit
#	STATUS doing hg commit
#	Time: real 0.010 secs (user 0.020+0.000 sys 0.000+0.000)
#	STATUS commit done
#	STATUS next step is to oh unwrap
#	STATUS total elapsed time 0 seconds aka 0 minutes
#	STATUS doing unwrap
#	STATUS doing hg update
#	Time: real 0.010 secs (user 0.010+0.000 sys 0.000+0.000)
#	resolving manifests
#	0 files updated, 0 files merged, 0 files removed, 0 files unresolved
#	STATUS doing omar extract
#	0.02 user 0.01 system 0:00.04 elapsed
#	STATUS unwrap done
#	STATUS next step is to write files to the 'oh' dir
#	STATUS total elapsed time 0 seconds aka 0 minutes
#	STATUS snapshot done
#	STATUS total elapsed time 1 seconds aka 0 minutes
